/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;

namespace BMS.CLASSES
{
    class cls_CHEQUE_BOOK:cls_GLOBAL_VARIABLES
    {
        #region Fields
        private int intChequeBookID;
        private string strChequeBookNo;
        private int intAccountID;
        private DateTime dtDateIssued;
        private string strStartNo;
        private string strEndNo;
        private int intNoOfCheques;
        private int intChequeID;
        private string strChequeNo;
        #endregion

        #region Properties
        public int IntChequeBookID
        {
            get { return intChequeBookID; }
            set { intChequeBookID = value; }
        }

        public string StrChequeBookNo
        {
            get { return strChequeBookNo; }
            set { strChequeBookNo = value; }
        }

        public int IntAccountID
        {
            get { return intAccountID; }
            set { intAccountID = value; }
        }

        public DateTime DtDateIssued
        {
            get { return dtDateIssued; }
            set { dtDateIssued = value; }
        }

        public string StrStartNo
        {
            get { return strStartNo; }
            set { strStartNo = value; }
        }

        public string StrEndNo
        {
            get { return strEndNo; }
            set { strEndNo = value; }
        }

        public int IntNoOfCheques
        {
            get { return intNoOfCheques; }
            set { intNoOfCheques = value; }
        }

        public int IntChequeID
        {
            get { return intChequeID; }
            set { intChequeID = value; }
        }

        public string StrChequeNo
        {
            get { return strChequeNo; }
            set { strChequeNo = value; }
        }
        #endregion

        public static void loadChequeBooks(ComboBox  cbo)
        {
            cls_DATABASE.GetRecord("SELECT ChequeBookID,ChequeBookNo FROM tb_CHEQUE_BOOKS");
            cls_LIST_ITEM cls_LIST_ITEM_obj = new cls_LIST_ITEM();
            cbo.Items.Clear();

            while (dataReader.Read())
            {
                cls_LIST_ITEM_obj = new cls_LIST_ITEM(dataReader["ChequeBookNo"].ToString(), Convert.ToInt32(cls_GLOBAL_VARIABLES.dataReader["ChequeBookID"]));
                cbo.Items.Add(cls_LIST_ITEM_obj);
            }
            dataReader.Close();
        }

        public void loadChequeBookDetails(int intChequeBookID)
        {
            cls_DATABASE.GetRecord("SELECT * FROM tb_CHEQUE_BOOKS WHERE ChequeBookID=" + intChequeBookID);

            if (dataReader.Read())
            {
                strChequeBookNo = dataReader["ChequeBookNo"].ToString();
                intAccountID  =Convert.ToInt16( dataReader["AccountID"]);
                dtDateIssued = DateTime.Parse(dataReader["DateIssued"].ToString());
            }
            dataReader.Close();
        }

        public void loadCheques(ListView lvw, int intChequeBookID)
        {
            cls_DATABASE.GetRecord("SELECT * FROM tb_CHEQUE_BOOK_DETAILS WHERE ChequeBookID=" + intChequeBookID);
            lvw.Items.Clear();

            ListViewItem lvwItem;

            while (dataReader.Read())
            {
                lvwItem = lvw.Items.Add(dataReader["ChequeNo"].ToString());
                if (Convert.ToInt16(dataReader["Status"]) == 0){lvwItem.SubItems.Add("UnUsed");}
                else{lvwItem.SubItems.Add("Used");}
            }
            dataReader.Close();
        }

        public static void loadAccountNo(ComboBox cbo)
        {
            cls_DATABASE.GetRecord("SELECT DISTINCT(AccountID),AccountNumber FROM vw_ACCOUNT_DETAILS WHERE CanHaveChequeBook=1");
            cbo.Items.Clear();
            cls_LIST_ITEM cls_LIST_ITEM_obj;

            while (dataReader.Read())
            {
                cls_LIST_ITEM_obj = new cls_LIST_ITEM(dataReader["AccountNumber"].ToString(), Convert.ToInt32(cls_GLOBAL_VARIABLES.dataReader["AccountID"]));
                cbo.Items.Add(cls_LIST_ITEM_obj);
            }
            dataReader.Close();
        }

        //public int CanHaveChequeBook(int intAccountID)
        //{
        //    cls_DATABASE.GetRecord("SELECT CanhaveChequeBook FROM vw_CHEQUE_BOOK_DETAILS WHERE AccountID=" + intAccountID);

        //    //if (dataReader.Read())
        //    //{
        //    return Convert.ToInt16(dataReader["CanHaveChequeBook"]);
        //    //}
        //    dataReader.Close();
        //}


        public int saveChequeBook()
        {
            string strSQL = "INSERT INTO tb_CHEQUE_BOOKS(ChequeBookID,ChequeBookNo,AccountID,DateIssued)" +
                " VALUES ( " + intChequeBookID + ","
                + "'" + strChequeBookNo + "',"
                + "" + intAccountID  + ","
                + "'" + dtDateIssued  + "')";

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public void saveCheque()
        {
            string strSQL = "INSERT INTO tb_CHEQUE_BOOK_DETAILS(ChequeNo,ChequeBookID)" +
                " VALUES ( '" + strChequeNo + "',"
                + "" + intChequeBookID  + ")";

            cls_DATABASE.SaveRecord(strSQL);
        }

        public static int AutogenID()
        {
            cls_DATABASE.GetRecord("SELECT ChequeBookID FROM tb_CHEQUE_BOOKS ORDER BY ChequeBookID DESC");
            int intResult = 0;

            if (dataReader.Read())
            {
                intResult = Convert.ToInt32(dataReader["ChequeBookID"]);
                return intResult + 1;
            }
            else { return 1; }
        }

        public static string AutoGenChequeBookNo()
        {
            cls_DATABASE.GetRecord("SELECT ChequeBookNo FROM tb_CHEQUE_BOOKS ORDER BY ChequeBookID DESC");
            if (cls_DATABASE.dataReader.Read())
            {
                string strChequeBookNo = cls_DATABASE.dataReader["ChequeBookNo"].ToString();
                int intLastNo = int.Parse(strChequeBookNo.Substring(3, 10)) + 1;
                return "CB-" + intLastNo.ToString("0000000000");
            }
            else { return "CB-0000000001"; }
        }

        public static void AutoGenChequeNo(ListView lvw, int intX)
        {
            cls_DATABASE.GetRecord("SELECT ChequeNo FROM tb_CHEQUE_BOOK_DETAILS ORDER BY ChequeID DESC");
            ListViewItem lvwItem;
            
            if (cls_DATABASE.dataReader.Read())
            {
                string strChequeBookNo = cls_DATABASE.dataReader["ChequeNo"].ToString();
                for (int x = 1; x <= intX; x++)
                {
                    int intLastNo = int.Parse(strChequeBookNo.Substring(2, 10)) + x;
                    lvwItem=lvw.Items.Add("C-" + intLastNo.ToString("0000000000"));
                }
            }
            else 
            {
                string strChequeBookNo = "C-0000000001";
                for (int x = 1; x <= intX; x++)
                {
                    int intLastNo = int.Parse(strChequeBookNo.Substring(2, 10)) + x;
                    lvwItem = lvw.Items.Add("C-" + intLastNo.ToString("0000000000"));
                }
            }
        }
    }
}
