/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using Microsoft.Reporting.WinForms;

namespace BMS.CLASSES
{
    class cls_TRANSACTIONS:cls_GLOBAL_VARIABLES 
    {
        #region Fields
        int intTransactionID;
        DateTime dtTransactionDate;
        int intTransactionTypeID;
        string strTransactionMode;
        int intFromAccountID;
        string strFromAccountNo;
        int intToAccountID;
        string strToAccountNo;
        int intChequeNumber;
        string strChequeNumber;
        long lngAmount;
        long lngTotalBalance;
        int intStatus;
        string strDepositedBy;
        string strBankName;
        #endregion

        #region Properties
        public int IntTransactionID
        {
            get { return intTransactionID; }
            set { intTransactionID = value; }
        }

        public DateTime DtTransactionDate
        {
            get { return dtTransactionDate; }
            set { dtTransactionDate = value; }
        }

        public int IntTransactionTypeID
        {
            get { return intTransactionTypeID; }
            set { intTransactionTypeID = value; }
        }

        public string StrTransactionMode
        {
            get { return strTransactionMode; }
            set { strTransactionMode = value; }
        }

        public int IntFromAccountID
        {
            get { return intFromAccountID; }
            set { intFromAccountID = value; }
        }
        public string StrFromAccountNo
        {
            get { return strFromAccountNo; }
            set { strFromAccountNo = value; }
        }
        public int IntToAccountID
        {
            get { return intToAccountID; }
            set { intToAccountID = value; }
        }
        public string StrToAccountNo
        {
            get { return strToAccountNo; }
            set { strToAccountNo = value; }
        }

        public int IntChequeNumber
        {
            get { return intChequeNumber; }
            set { intChequeNumber = value; }
        }

        public string StrChequeNumber
        {
            get { return strChequeNumber; }
            set { strChequeNumber = value; }
        }

        public long LngAmount
        {
            get { return lngAmount; }
            set { lngAmount = value; }
        }

        public long LngTotalBalance
        {
            get { return lngTotalBalance; }
            set { lngTotalBalance = value; }
        }

        public int IntStatus
        {
            get { return intStatus; }
            set { intStatus = value; }
        }

        public string StrDepositedBy
        {
            get { return strDepositedBy; }
            set { strDepositedBy = value; }
        }

        public string StrBankName
        {
            get { return strBankName; }
            set { strBankName = value; }
        }

        #endregion

        public static void searchTransactions(ListView lvw, string strSQL)
        {
            cls_DATABASE.GetRecord("SELECT * FROM vw_TRANSACTION_DETAILS WHERE " + strSQL);

            lvw.Items.Clear();
            ListViewItem lst;

            while (dataReader.Read())
            {
                lst = lvw.Items.Add(dataReader["TransactionID"].ToString());
                lst.SubItems.Add(DateTime.Parse( dataReader["TransactionDate"].ToString()).ToShortDateString());
                lst.SubItems.Add(dataReader["TransactionType"].ToString());
                lst.SubItems.Add(dataReader["FromAccountNo"].ToString());
                lst.SubItems.Add(dataReader["ToAccountNo"].ToString());
                lst.SubItems.Add(dataReader["ChequeNumber"].ToString());
                lst.SubItems.Add(dataReader["Amount"].ToString());
                if (Convert.ToInt16(dataReader["Status"]) == 0) { lst.SubItems.Add("Pending"); }
                else { lst.SubItems.Add("Posted"); }
                lst.SubItems.Add(dataReader["DepositedBy"].ToString());
                lst.SubItems.Add(dataReader["Status"].ToString());
                lst.SubItems.Add(dataReader["FromAccountID"].ToString());
                lst.SubItems.Add(dataReader["ToAccountID"].ToString());

            }

            dataReader.Close();
        }

        public static void searchBankStatement(ListView lvw, string strSQL,int intAccountID)
        {
            cls_DATABASE.GetRecord("SELECT * FROM vw_TRANSACTION_DETAILS WHERE " + strSQL + " AND Status = 1");

            lvw.Items.Clear();
            ListViewItem lst;

            while (dataReader.Read())
            {
                lst = lvw.Items.Add(dataReader["TransactionID"].ToString());
                lst.SubItems.Add(DateTime.Parse(dataReader["TransactionDate"].ToString()).ToShortDateString());
                lst.SubItems.Add(dataReader["TransactionType"].ToString());
                switch (Convert.ToInt16(dataReader["TransactionTypeID"]))
                {
                    case 1:
                        lst.SubItems.Add("0");
                        lst.SubItems.Add(dataReader["Amount"].ToString());
                        break;

                    case 2:
                        lst.SubItems.Add("0");
                        lst.SubItems.Add(dataReader["Amount"].ToString());
                        break;

                    case 3:
                        lst.SubItems.Add(dataReader["Amount"].ToString());
                        lst.SubItems.Add("0");
                        break;

                    case 4:
                        if (Convert.ToInt16(dataReader["FromAccountID"]) == intAccountID)
                        {
                            lst.SubItems.Add(dataReader["Amount"].ToString());
                            lst.SubItems.Add("0");
                        }
                        else
                        {
                            lst.SubItems.Add("0");
                            lst.SubItems.Add(dataReader["Amount"].ToString());
                        }
                        break;
                }
                
                
            }

            dataReader.Close();
        }

        public int saveTransactions()
        {
            string strSQL = "INSERT INTO tb_TRANSACTIONS(TransactionID,TransactionDate,TransactionTypeID,TransactionMode,FromAccountID,FromAccountNo,ToAccountID,ToAccountNo,ChequeNo,ChequeNumber,Amount,Status,DepositedBy)" +
                " VALUES(" + intTransactionID   + ","
                + "'" + dtTransactionDate + "',"
                + "" + intTransactionTypeID  + ","
                + "'" + strTransactionMode  + "',"
                + "" + intFromAccountID  + ","
                + "'" + strFromAccountNo  + "',"
                + "" + intToAccountID + ","
                + "'" + strToAccountNo  + "',"
                + "" + intChequeNumber  + ","
                + "'" + strChequeNumber  + "',"
                + "'" + lngAmount  + "',"
                + "'" + intStatus  + "',"
                + "'" + strDepositedBy  + "')";

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public static long loadBalance(int intAccountID)
        {
            cls_DATABASE.GetRecord("SELECT Balance FROM tb_ACCOUNTS WHERE AccountID=" + intAccountID );
            if (dataReader.Read())
            {
                return Convert.ToInt64(dataReader["Balance"]);
                dataReader.Close();
            }
            else { return 0; }
        }


        public static void loadTransactionReport(string strSQL, ReportViewer rdlcviewer, string strReportEmbeddedRessource, string strReportDataSourceName, int intTransactionID)
        {
            if (intTransactionID == 0) { cls_DATABASE.GetRecord("SELECT * FROM vw_TRANSACTION_DETAILS WHERE " + strSQL); }
            else
            { cls_DATABASE.GetRecord("SELECT * FROM vw_TRANSACTION_DETAILS WHERE TransactionID = " + intTransactionID + " AND " + strSQL); }

            ds_TABLES_obj.Tables[1].Clear();
            ds_TABLES_obj.Tables[1].Load(dataReader);
            rdlcviewer.LocalReport.ReportEmbeddedResource = strReportEmbeddedRessource;
            ReportDataSource reportDataSource = new ReportDataSource();
            reportDataSource.Name = strReportDataSourceName;
            reportDataSource.Value = ds_TABLES_obj.Tables[1];
            rdlcviewer.LocalReport.DataSources.Add(reportDataSource);
            rdlcviewer.RefreshReport();
            dataReader.Close();

        }

        public int saveTransactionDetails()
        {
            string strSQL = "INSERT INTO tb_TRANSACTION_DETAILS(TransactionID,BankName,ChequeNumber,Amount)" +
                " VALUES(" + intTransactionID + ","
                + "'" + strBankName + "',"
                + "'" + strChequeNumber + "',"
                + "" + lngAmount + ")";

            return cls_DATABASE.SaveRecord(strSQL);
        }

  

        public int updateBalance(int intAccountID)
        {
            string strSQL = "UPDATE tb_ACCOUNTS SET " +
                "BALANCE ='" + lngTotalBalance  + "'" +
                " WHERE AccountID=" + intAccountID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateTransferBalance(int intAccountTransferTo,long lngTotalBalance)
        {
            string strSQL = "UPDATE tb_ACCOUNTS SET " +
                "BALANCE = " + lngTotalBalance + " " +
                " WHERE AccountID=" + intAccountTransferTo;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateChequeStatus(int intChequeID)
        {
            string strSQL = "UPDATE tb_CHEQUE_BOOK_DETAILS SET " +
                "Status =1" +
                " WHERE ChequeID=" + intChequeID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateTransactionBalance(int intAccountID)
        {
            string strSQL = "UPDATE tb_ACCOUNTS SET " +
                "BALANCE = Balance + " + lngTotalBalance + "" +
                " WHERE AccountID=" + intAccountID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateTransactionStatus(int intTransactionID)
        {
            string strSQL = "UPDATE tb_TRANSACTIONS SET " +
                "Status = 1 "  +
                " WHERE TransactionID=" + intTransactionID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public static int AutogenID()
        {
            cls_DATABASE.GetRecord("SELECT TransactionID FROM tb_TRANSACTIONS ORDER BY TransactionID DESC");
            int intResult = 0;

            if (dataReader.Read())
            {
                intResult = Convert.ToInt32(dataReader["TransactionID"]);
                return intResult + 1;
            }
            else{return 1;}
        }

    }
}
