/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;

namespace BMS.CLASSES
{
    class cls_USERS:cls_GLOBAL_VARIABLES 
    {
        #region Fields
        private int intUserID;
        private string strUserName;
        private string strPassword;
        private string strNewPassword;
        private string strFullName;
        private int intStatus;
        private int intDeleted;
        private int intActive;
        private int intAdmin;
        private DateTime dtLastPasswordChangeDate;
        private DateTime dtLastLoginDate;
        private string strLastLoginWorkstation;
        private int intLocationID;
        private string strWorkStationName;
        private DateTime dtLoginDate;
        private string strLoginType;
        private string strDescription;
        private string strPicture;
        private int intUserFeatureID;
        #endregion

        #region Properties
        public int IntUserID
        {
            get { return intUserID; }
            set { intUserID = value; }
        }       

        public string StrUserName
        {
            get { return strUserName; }
            set { strUserName = value; }
        }

        public string StrPassword
        {
            get { return strPassword; }
            set { strPassword = value; }
        }

        public string StrNewPassword
        {
            get { return strNewPassword; }
            set { strNewPassword = value; }
        }

        public string StrFullName
        {
            get { return strFullName; }
            set { strFullName = value; }
        }

        public int IntStatus
        {
            get { return intStatus; }
            set { intStatus = value; }
        }

        public int IntDeleted
        {
            get { return intDeleted; }
            set { intDeleted = value; }
        }

        public int IntActive
        {
            get { return intActive; }
            set { intActive = value; }
        }

        public int IntAdmin
        {
            get { return intAdmin; }
            set { intAdmin = value; }
        }

        public DateTime DtLastPasswordChangeDate
        {
            get { return dtLastPasswordChangeDate; }
            set { dtLastPasswordChangeDate = value; }
        }

        public DateTime DtLastLoginDate
        {
            get { return dtLastLoginDate; }
            set { dtLastLoginDate = value; }
        }

        public string StrLastLoginWorkstation
        {
            get { return strLastLoginWorkstation; }
            set { strLastLoginWorkstation = value; }
        }

        public int IntLocationID
        {
            get { return intLocationID; }
            set { intLocationID = value; }
        }

        public string StrWorkStationName
        {
            get { return strWorkStationName; }
            set { strWorkStationName = value; }
        }


        public DateTime DtLoginDate
        {
            get { return dtLoginDate; }
            set { dtLoginDate = value; }
        }


        public string StrLoginType
        {
            get { return strLoginType; }
            set { strLoginType = value; }
        }


        public string StrDescription
        {
            get { return strDescription; }
            set { strDescription = value; }
        }

        public string StrPicture
        {
            get { return strPicture; }
            set { strPicture = value; }
        }

        public int IntUserFeatureID
        {
            get { return intUserFeatureID; }
            set { intUserFeatureID = value; }
        }
        #endregion

        public cls_USERS()
        {
            intUserID = 0;
            strUserName = string.Empty;
            strPassword = string.Empty;
        }

        public bool CheckUserLogin()
        {
            cls_DATABASE.GetRecord("SELECT UserID FROM tb_USERS WHERE UserName='" + strUserName+ "' AND Password='" + strPassword+"'");

            if (dataReader.Read()) {intUserID =Convert.ToInt32( cls_GLOBAL_VARIABLES.dataReader["UserID"]);  return true; } else { return false; }
        }

        public static void loadUsers(ComboBox cbo)
        {
            cls_DATABASE.GetRecord("SELECT UserID,UserName FROM tb_USERS");
            cls_LIST_ITEM cls_LIST_ITEM_obj = new cls_LIST_ITEM();

            cbo.Items.Clear();

            while (dataReader.Read())
            {
                cls_LIST_ITEM_obj = new cls_LIST_ITEM(dataReader["UserName"].ToString(), Convert.ToInt32(cls_GLOBAL_VARIABLES.dataReader["UserID"]));
                cbo.Items.Add(cls_LIST_ITEM_obj);
            }
            dataReader.Close();
        }

        public void loadUserDetails(int intUserID)
        {
            cls_DATABASE.GetRecord("SELECT * FROM tb_USERS WHERE UserID = " + intUserID );

            if (dataReader.Read())
            {
                strUserName = dataReader["UserName"].ToString();
                strFullName = dataReader["FullName"].ToString();
                strPassword = dataReader["Password"].ToString();
                intStatus = Convert.ToInt32(dataReader["Status"]);
                intDeleted = Convert.ToInt32(dataReader["Deleted"]);
                intActive = Convert.ToInt32(dataReader["Active"]);
                intAdmin = Convert.ToInt32(dataReader["Admin"]);
                if ((dataReader["LastLoginDate"].ToString()) == ""){DtLastLoginDate = DateTime.Today;}
                else{DtLastLoginDate = DateTime.Parse((dataReader["LastLoginDate"]).ToString());}
                strLastLoginWorkstation=dataReader["LastLoginWorkstation"].ToString();
                strPicture = dataReader["Picture"].ToString();
            }
            dataReader.Close();
        }

        public int resetUserPassword(int intUserID)
        {
            string strSQL= "UPDATE tb_USERS SET [Password]='password' WHERE UserID = " + intUserID ;

            return cls_DATABASE.SaveRecord(strSQL );
        }

        public int setUserAccountStatus(int intUserID,int intStatus)
        {
            string strSQL = "UPDATE tb_USERS SET Status= " + intStatus + " WHERE UserID = " + intUserID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int setUserInActive(int intUserID)
        {
            string strSQL = "UPDATE tb_USERS SET Active= 0 WHERE UserID = " + intUserID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int saveUserDetails()
        {
            string strSQL = "INSERT INTO tb_USERS(UserID,UserName,[Password],FullName,Picture)" +
                " VALUES ( " + intUserID  + ","
                + "'" + strUserName + "',"
                + "'" + strPassword + "',"
                + "'" + strFullName + "',"
                + "'" + strPicture  + "')";

            return cls_DATABASE.SaveRecord(strSQL);
        }


        public int saveUserFeatures(int intUserID)
        {
            string strSQL = "INSERT INTO tb_USERS_FEATURES(UserID,FeatureID)" +
            " VALUES ( " + intUserID  + ","
            + "" + intUserFeatureID + ")";

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int deleteUserFeatures(int intUserID)
        {
            string strSQL = "DELETE FROM tb_USERS_FEATURES WHERE UserID=" + intUserID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateUserDetails(int intUserID)
        {
            string strSQL = "UPDATE tb_USERS SET " +
                "UserName ='" + strUserName + "'," +
                "[Password] ='" + strPassword + "'," +
                "FullName ='" + strFullName  + "'," +
                "Picture ='" + strPicture  + "'" +
                " WHERE UserID=" + intUserID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateUserLogInDetails(int intUserID)
        {
            string strSQL = "UPDATE tb_USERS SET " +
                "Active =1," +
                "LastLoginDate ='" + DateTime.Today + "'," +
                "LastLoginWorkStation ='" + strWorkStationName + "'" +
                " WHERE UserID=" + intUserID ;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateUserLogOutDetails(int intUserID)
        {
            string strSQL = "UPDATE tb_USERS SET " +
                "Active =0" +
                " WHERE UserID=" + intUserID;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int updateUserPassword(int intUserID)
        {
            string strSQL = "UPDATE tb_USERS SET " +
                "UserName ='" + strUserName + "'," +
                "[Password] ='" + strNewPassword + "'," +
                "LastPasswordChangeDate ='" + DateTime.Today + "'" +
                " WHERE UserID=" + intUserID ;

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int saveUserAccessLogIn(int intUserID)
        {
            string strSQL = "INSERT INTO tb_USERS_ACCESS_LOGS(UserID,WorkStationName,LogDate,LogType,Description)" +
                " VALUES ( '" + intUserID  + "',"
                + "'" + strWorkStationName + "',"
                + "'" + DateTime.Now + "',"
                + "1,"
                + "'User Logged In' )";

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public int saveUserAccessLogOut(int intUserID)
        {
            string strSQL = "INSERT INTO tb_USERS_ACCESS_LOGS(UserID,WorkStationName,LogDate,LogType,Description)" +
                " VALUES ( '" + intUserID + "',"
                + "'" + strWorkStationName + "',"
                + "'" + DateTime.Now  + "',"
                + "2,"
                + "'User Logged Out' )";

            return cls_DATABASE.SaveRecord(strSQL);
        }

        public static int AutogenID()
        {
            cls_DATABASE.GetRecord("SELECT UserID FROM tb_USERS ORDER BY UserID DESC");
            int intResult = 0;

            if (dataReader.Read())
            {
                intResult = Convert.ToInt32(dataReader["UserID"]);
                return intResult + 1;
            }
            else { return 1; }
        }

    }
}
