/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Text.RegularExpressions;


using BMS.FORMS;
using System.Drawing.Imaging;

namespace BMS.CLASSES
{
    class cls_UTILITY:cls_GLOBAL_VARIABLES 
    {

        public static bool checkEmptyTextBox(TextBox txt, string strMessage)
        {
            if (txt.Text.Trim() == string.Empty)
            {
                displayMessage("Fields with (*) are compulsory. \n" + strMessage, MessageBoxIcon.Exclamation);
                txt.Focus();
                return true;
            }else{return false;}
            
        }

        public static bool checkComboBox(ComboBox  cbo, string strMessage)
        {
            if (cbo.SelectedIndex==-1)
            {
                displayMessage("Fields with (*) are compulsory. \n" + strMessage, MessageBoxIcon.Exclamation);
                cbo.Focus();
                return true;
            }else{return false;}

        }

        public static bool checkImage(PictureBox pic, string strMessage)
        {
            if (pic.Image  == null )
            {
                displayMessage(strMessage, MessageBoxIcon.Exclamation);
                return true;
            }
            else { return false; }

        }

        public static bool validateEmail(TextBox txt,string strMessage)
        {
            if (!Regex.IsMatch(txt.Text, @"^([\w-]+\.)*?[\w-]+@[\w-]+\.([\w-]+\.)*?[\w]+$"))
            {
                displayMessage(strMessage, MessageBoxIcon.Exclamation);
                txt.Focus();
                return true;
            }
            else{return false  ;}
        }

        public static bool displayMessage(string strMessage)
        {
            DialogResult dialogResult = MessageBox.Show(strMessage, strApplicationName, MessageBoxButtons.YesNo, MessageBoxIcon.Question );
            if (dialogResult == DialogResult.Yes){return true;}
            else{return false;}
        }

        public static void displayMessage(string strMessage,MessageBoxIcon msgBoxIcon)
        {
            MessageBox.Show(strMessage,strApplicationName,MessageBoxButtons.OK,msgBoxIcon);
        }

        public static bool checkPrevInstance()
        {
            if (System.Diagnostics.Process.GetProcessesByName(System.Diagnostics.Process.GetCurrentProcess().ProcessName).Length > 1){return true;}
            else{return false;}
        }

        public static void ClearFields(Control ctrl)
        {
            foreach (Control ctl in ctrl.Controls)
            {
                if (ctl is TextBox){ctl.Text = string.Empty;}
                else if (ctl is ComboBox){((ComboBox)ctl).SelectedIndex  = -1;}
                else if (ctl is DateTimePicker){((DateTimePicker)ctl).Value = DateTime.Today;}
                //else if (ctl is DateTimePicker){((DateTimePicker)ctl).Checked  = false;}
                else if (ctl is PictureBox){((PictureBox)ctl).Image = null;}
                else if (ctl is CheckBox) { ((CheckBox)ctl).Checked = false;}
                else if (ctl is ListView) { ((ListView)ctl).Items.Clear(); }
            }
        }

        public static void disableFields(Control ctrl)
        {
            foreach (Control ctl in ctrl.Controls)
            {
                if (ctl is TextBox){((TextBox)ctl).Enabled = false ;}
                else if (ctl is ComboBox){((ComboBox)ctl).Enabled = false;}
                else if (ctl is DataGridView) { ((DataGridView)ctl).Enabled = false; }
                else if (ctl is DateTimePicker){((DateTimePicker)ctl).Enabled = false;}
                else if (ctl is Button ){((Button)ctl).Enabled = false;}
                else if (ctl is CheckBox) { ((CheckBox)ctl).Enabled = false ; }
                else if (ctl is ListView) { ((ListView)ctl).Enabled = false; }
            }
        }

        public static void enableFields(Control ctrl)
        {
            foreach (Control ctl in ctrl.Controls)
            {
                if (ctl is TextBox){((TextBox)ctl).Enabled = true ;}
                else if (ctl is ComboBox){((ComboBox)ctl).Enabled = true;}
                else if (ctl is DataGridView) { ((DataGridView)ctl).Enabled = true; }
                else if (ctl is DateTimePicker){((DateTimePicker)ctl).Enabled = true;}
                else if (ctl is Button){((Button)ctl).Enabled = true ;}
                else if (ctl is CheckBox) { ((CheckBox)ctl).Enabled = true; }
                else if (ctl is ListView) { ((ListView)ctl).Enabled = true; }
            }
        }

        public static bool CopyImage(string strPictureSource,string strDestination ,string strFileName)
        {
            try
            {
                if (Directory.Exists(strDestination))
                {
                    File.Copy(strPictureSource, strDestination + @"\" + strFileName, false);
                }
                else
                {
                    Directory.CreateDirectory(strDestination);
                    File.Copy(strPictureSource, strDestination + @"\" + strFileName, false);
                }
                return  true;
            }
            catch (Exception exc)
            {
                return  false;
            }
        }

        public static void DeleteImage(string strDestination, string strFileName)
        {
            if (Directory.Exists(strDestination))
            {
                File.Delete(strDestination + @"\" + strFileName);
            }
        }


        public static byte[] GetImage(PictureBox pictureBox)
        {
            MemoryStream memoryStream = new MemoryStream();
            pictureBox.Image.Save(memoryStream, pictureBox.Image.RawFormat);
            byte[] byteImage = new byte[memoryStream.Length];
            memoryStream.Position = 0;
            memoryStream.Read(byteImage, 0, Convert.ToInt32(memoryStream.Length));
            memoryStream.Close();
            return byteImage;
        }


        public static void loadImage(PictureBox pictureBox,byte[] byteImage)
        {
            try
            {
                MemoryStream memoryStream = new MemoryStream(byteImage );
                pictureBox.Image = Image.FromStream(memoryStream);
                //pictureBox.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            catch (Exception ex) { 
                //displayMessage(ex.Message, MessageBoxIcon.Error); 
            }
        }

        public void GetItem(ComboBox cbo, int intID)
        {
            foreach (cls_LIST_ITEM cls_LIST_ITEM_obj in cbo.Items)
            {
                if (cls_LIST_ITEM_obj.ListID == intID)
                {
                    cbo.SelectedItem = cls_LIST_ITEM_obj;
                    break;
                }
            }
        }


        public static void uncheckLvwItem(ListView lvw)
        {
            foreach (ListViewItem lvwItem in lvw.Items)
            {
                lvwItem.Checked = false;
            }
        }

        public string IntegerToWords(long inputNum)
        {
            int dig1, dig2, dig3, level = 0, lasttwo, threeDigits;

            string retval = "";
            string x = "";
            string[] ones ={"zero","one","two","three","four","five","six","seven","eight","nine","ten","eleven","twelve","thirteen","fourteen","fifteen","sixteen","seventeen","eighteen","nineteen"};
            string[] tens ={"zero","ten","twenty","thirty","forty","fifty","sixty","seventy","eighty","ninety"};
            string[] thou ={"","thousand","million","billion","trillion","quadrillion","quintillion"};

            bool isNegative = false;
            if (inputNum < 0)
            {
                isNegative = true;
                inputNum *= -1;
            }

            if (inputNum == 0)
                return ("zero");

            string s = inputNum.ToString();

            while (s.Length > 0)
            {
                // Get the three rightmost characters
                x = (s.Length < 3) ? s : s.Substring(s.Length - 3, 3);

                // Separate the three digits
                threeDigits = int.Parse(x);
                lasttwo = threeDigits % 100;
                dig1 = threeDigits / 100;
                dig2 = lasttwo / 10;
                dig3 = (threeDigits % 10);

                // append a "thousand" where appropriate
                if (level > 0 && dig1 + dig2 + dig3 > 0)
                {
                    retval = thou[level] + " " + retval;
                    retval = retval.Trim();
                }

                // check that the last two digits is not a zero
                if (lasttwo > 0)
                {
                    if (lasttwo < 20) // if less than 20, use "ones" only
                        retval = ones[lasttwo] + " " + retval;
                    else // otherwise, use both "tens" and "ones" array
                        retval = tens[dig2] + " " + ones[dig3] + " " + retval;
                }

                // if a hundreds part is there, translate it
                if (dig1 > 0)
                    retval = ones[dig1] + " hundred " + retval;

                s = (s.Length - 3) > 0 ? s.Substring(0, s.Length - 3) : "";
                level++;
            }

            while (retval.IndexOf("  ") > 0)
                retval = retval.Replace("  ", " ");

            retval = retval.Trim();

            if (isNegative)
                retval = "negative " + retval;

            return (retval);
        }

        public static string getComputerName()
        {
            return Environment.MachineName;
        }

    }
}
