/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_ACCOUNT_TYPES : Form
    {

        int intAccountTypeID = 0;
        cls_ACCOUNT_TYPES cls_ACCOUNT_TYPES_obj = new cls_ACCOUNT_TYPES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_ACCOUNT_TYPES()
        {
            InitializeComponent();
        }

        private void btnClose_Click(object sender, EventArgs e){Close();}

        private void frm_ACCOUNT_TYPES_Load(object sender, EventArgs e)
        {
            cls_ACCOUNT_TYPES.loadAccountTypes(cboAccountTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboAccountTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccountTypes.SelectedItem;
            intAccountTypeID = cls_LIST_ITEM_obj.ListID;
            loadAccountDetails(intAccountTypeID);
        }

        private void loadAccountDetails(int intAccountTypeID)
        {
            cls_ACCOUNT_TYPES_obj.loadAccountTypesDetails(intAccountTypeID);

            txtAccountType.Text = cls_ACCOUNT_TYPES_obj.StrAccountType;
            txtMinimumBalance.Text = cls_ACCOUNT_TYPES_obj.StrMinimumBalance;
            txtRate.Text = cls_ACCOUNT_TYPES_obj.StrRate;
            txtDescription.Text = cls_ACCOUNT_TYPES_obj.StrDescription;
            if (cls_ACCOUNT_TYPES_obj.IntCanHaveChequeBook == 0){chkChequeBook.Checked = false;}
            else{chkChequeBook.Checked = true ;}
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboAccountTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboAccountTypes.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intAccountTypeID == 0 || txtAccountType.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the account type to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtAccountType, "Please enter the account type") == false) { disableCtl(); }

            cls_ACCOUNT_TYPES_obj.StrAccountType = txtAccountType.Text.Trim();
            cls_ACCOUNT_TYPES_obj.StrMinimumBalance = txtMinimumBalance.Text.Trim();
            cls_ACCOUNT_TYPES_obj.StrRate = txtRate.Text.Trim();
            cls_ACCOUNT_TYPES_obj.StrDescription = txtDescription.Text.Trim();
            if (chkChequeBook.Checked == true) { cls_ACCOUNT_TYPES_obj.IntCanHaveChequeBook = 1; }
            else { cls_ACCOUNT_TYPES_obj.IntCanHaveChequeBook = 0; }


            if (blAdd == true && blEdit == false)
            {
                if (cls_ACCOUNT_TYPES_obj.saveAccountTypeDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_ACCOUNT_TYPES.loadAccountTypes(cboAccountTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_ACCOUNT_TYPES_obj.updateAccountTypeDetails(intAccountTypeID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_ACCOUNT_TYPES.loadAccountTypes(cboAccountTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }

        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intAccountTypeID == 0 || txtAccountType.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the account type to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the account type. It might be referenced somewhere else.",MessageBoxIcon.Error );
        }

        private void cboAccountTypes_KeyPress(object sender, KeyPressEventArgs e){e.Handled = true;}

        private void frm_ACCOUNT_TYPES_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (frm_BANK_ACCOUNTS.int_frm_ACCOUNT_TYPE_ID == 1)
            {
                cls_ACCOUNT_TYPES.loadAccountTypes(frm_BANK_ACCOUNTS.frm_BANK_ACCOUNTS_obj.cboAccountType);
            }
        }
    }
}