/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_BANK_ACCOUNTS : DockableWindow
    {
        bool blAdd = false;
        bool blEdit = false;

        int intIdentificationDetailID = 0;
        int intNewAccountID = 0;
        int intAccountID=0;
        int intCustomerTypeID = 0;
        int intGenderID = 0;
        int intTitleID = 0;
        int intIdentificationID = 0;
        int intAccountTypeID = 0;
        int intCurrencyID = 0;

        //string strPictureDestination = Application.StartupPath + @"\PICTURES";
        
        string strPictureSource;
        string strPictureExtension;
        string strPictureName;
        string strCurrentPictureName;

        string strDigitalSignSource;
        string strDigitalSignExtension;
        string strDigitalSignName;
        string strCurrentSignName;

        public static int int_frm_CUSTOMER_TYPE_ID = 0;
        public static int int_frm_TITLE_TYPE_ID = 0;
        public static int int_frm_IDENTIFICATION_TYPE_ID = 0;
        public static int int_frm_ACCOUNT_TYPE_ID = 0;
        public static int int_frm_CURRENCY_TYPE_ID = 0;

        cls_BANK_ACCOUNTS cls_BANK_ACCOUNTS_obj = new cls_BANK_ACCOUNTS();
        cls_UTILITY cls_UTILITY_obj = new cls_UTILITY();
        public static frm_BANK_ACCOUNTS frm_BANK_ACCOUNTS_obj;

        public frm_BANK_ACCOUNTS()
        {
            InitializeComponent();
        }

        private void frm_BANK_ACCOUNTS_Load(object sender, EventArgs e)
        {
            frm_BANK_ACCOUNTS_obj = this;
            disableCtl();
            disableFields();
            fillComboBoxes();
        }

        public void fillComboBoxes()
        {
            cls_CUSTOMER_TYPES.loadCustomerTypes(cboCustomerType);
            cls_TITLE_TYPES.loadTitleTypes(cboTitle);
            cls_BANK_ACCOUNTS.loadGender(cboGender);
            cls_IDENTIFICATION_TYPES.loadIdentificationType(cboIdentification);
            cls_ACCOUNT_TYPES.loadAccountTypes(cboAccountType);
            cls_CURRENCY_TYPES.loadCurrency(cboCurrencyType);
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccounts);
        }

        private void cboAccounts_SelectedIndexChanged(object sender, EventArgs e)
        {
            //try
            //{
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccounts.SelectedItem;
                intAccountID = cls_LIST_ITEM_obj.ListID;
                loadAccountDetails(intAccountID);
            //}
            //catch (Exception ex) { }
        }

        private void loadAccountDetails(int intAccountID)
        {
            cls_BANK_ACCOUNTS_obj.loadAccountDetails(intAccountID);


            cls_UTILITY_obj.GetItem(cboCustomerType, cls_BANK_ACCOUNTS_obj.IntHolderType);
            txtSurname.Text = cls_BANK_ACCOUNTS_obj.StrSurname;
            txtOtherNames.Text = cls_BANK_ACCOUNTS_obj.StrOtherNames;
            txtMaidenName.Text = cls_BANK_ACCOUNTS_obj.StrMaidenName;
            cls_UTILITY_obj.GetItem(cboTitle, cls_BANK_ACCOUNTS_obj.IntTitleID);
            cls_UTILITY_obj.GetItem(cboGender, cls_BANK_ACCOUNTS_obj.IntGender);
            dtpDateOfBirth.Value = cls_BANK_ACCOUNTS_obj.DtdateOfBirth;
            txtPlaceOfBirth.Text = cls_BANK_ACCOUNTS_obj.StrPlaceOfBirth;
            txtOccupation.Text = cls_BANK_ACCOUNTS_obj.StrOccupation;
            txtEmployer.Text = cls_BANK_ACCOUNTS_obj.StrEmployer;
            txtOfficePhone.Text = cls_BANK_ACCOUNTS_obj.StrOfficePhone;
            txtHomePhone.Text = cls_BANK_ACCOUNTS_obj.StrHomePhone;
            txtMobilePhone.Text = cls_BANK_ACCOUNTS_obj.StrMobilePhone;
            txtPOBox.Text = cls_BANK_ACCOUNTS_obj.StrPOBox;
            txtEMailAddress.Text = cls_BANK_ACCOUNTS_obj.StrEmail;
            txtNationality.Text = cls_BANK_ACCOUNTS_obj.StrNationality;

            if (cls_BANK_ACCOUNTS_obj.StrPicture == "") { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp");strCurrentPictureName=""; }
            else { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrPicture); strCurrentPictureName = cls_BANK_ACCOUNTS_obj.StrPicture; }

            if (cls_BANK_ACCOUNTS_obj.StrDigitalSign == "") { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoSignature.bmp");strCurrentSignName="" ; }
            else { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrDigitalSign); strCurrentSignName = cls_BANK_ACCOUNTS_obj.StrDigitalSign; }

            intIdentificationDetailID = cls_BANK_ACCOUNTS_obj.IntIdentificationDetailID;
            cls_UTILITY_obj.GetItem(cboIdentification, cls_BANK_ACCOUNTS_obj.IntIdentificationTypeID);
            txtIDNo.Text = cls_BANK_ACCOUNTS_obj.StrIdentificationNo;
            dtpDateIssued.Value = cls_BANK_ACCOUNTS_obj.DtDateIssued;
            txtIssuedAt.Text = cls_BANK_ACCOUNTS_obj.StrIssuedAt;
            txtIssuedBy.Text = cls_BANK_ACCOUNTS_obj.StrIssuedBy;
            txtResidencePermitNo.Text = cls_BANK_ACCOUNTS_obj.StrResidencePermitNo;

            lblAccountNo.Text = cls_BANK_ACCOUNTS_obj.StrAccountNo;
            txtAccountName.Text = cls_BANK_ACCOUNTS_obj.StrAccountName;
            cls_UTILITY_obj.GetItem(cboAccountType, cls_BANK_ACCOUNTS_obj.IntAccountType);
            cls_UTILITY_obj.GetItem(cboCurrencyType, cls_BANK_ACCOUNTS_obj.IntCurrencyType);
            txtInitialDeposit.Text = cls_BANK_ACCOUNTS_obj.StrInitialDeposit;
            lblBalance.Text = cls_BANK_ACCOUNTS_obj.StrBalance;
            dtpDateOpened.Value = cls_BANK_ACCOUNTS_obj.DtDateOpened;

            lblATMCardNo.Text = cls_BANK_ACCOUNTS_obj.StrATMCardNo;
            dtpATMDateIssued.Value = cls_BANK_ACCOUNTS_obj.DtATMIssuedDate;
            dtpATMExpiryDate.Value = cls_BANK_ACCOUNTS_obj.DtATMExpiryDate;
            txtATMAccesCode.Text = cls_BANK_ACCOUNTS_obj.StrATMAccessCode;



        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboAccounts.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

            btnBrowsePicture.Enabled = false;
            btnRemovePicture.Enabled = false;
            
            btnBrowseSignature.Enabled = false;
            btnRemoveSignature.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboAccounts.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;

            btnBrowsePicture.Enabled = true ;
            btnRemovePicture.Enabled = true;

            btnBrowseSignature.Enabled = true;
            btnRemoveSignature.Enabled = true;
        }

        private void enableFields()
        {
            cls_UTILITY.enableFields(grpBoxAccountHolderDetails);
            cls_UTILITY.enableFields(grpBoxAccountHolderIdentificationDetails);
            cls_UTILITY.enableFields(grpBoxAccountDetails);
            cls_UTILITY.enableFields(grpBoxATMDetails);
        }

        private void disableFields()
        {
            cls_UTILITY.disableFields(grpBoxAccountHolderDetails);
            cls_UTILITY.disableFields(grpBoxAccountHolderIdentificationDetails);
            cls_UTILITY.disableFields(grpBoxAccountDetails);
            cls_UTILITY.disableFields(grpBoxATMDetails);
        }

        private void clearFields()
        {
            cls_UTILITY.ClearFields(grpBoxAccountHolderDetails);
            cls_UTILITY.ClearFields(grpBoxAccountHolderIdentificationDetails);
            cls_UTILITY.ClearFields(grpBoxAccountDetails);
            cls_UTILITY.ClearFields(grpBoxATMDetails);
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            enableCtl();

            enableFields();
            clearFields();

            intNewAccountID = cls_BANK_ACCOUNTS.AutogenID();
            lblAccountNo.Text= cls_BANK_ACCOUNTS.AutoGenNo();
            intIdentificationDetailID = cls_BANK_ACCOUNTS.AutogenID(0);
            lblATMCardNo.Text = cls_BANK_ACCOUNTS.AutoGenCardNo();
            lblBalance.Text = "";

            tab.SelectTab(0);
            AccountHolderPicture.Image = null;
            AccountHolderDigitalSign.Image = null;
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intAccountID == 0 || txtSurname.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the account to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            enableFields();
            txtInitialDeposit.Enabled = false;
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intAccountID == 0 || txtSurname.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the account to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the account. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            disableFields();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            //disableCtl();
            if (cls_UTILITY.checkComboBox(cboCustomerType, "Please select the customer type") == true) { return; }
            if (cls_UTILITY.checkEmptyTextBox(txtSurname, "Please enter the surname") == true) {  return; }
            if (cls_UTILITY.checkEmptyTextBox(txtMaidenName, "Please enter the maiden name") == true) { return; }
            if (cls_UTILITY.checkComboBox(cboTitle, "Please select the title") == true) { return; }
            if (txtEMailAddress.Text.Trim() != "") { if (cls_UTILITY.validateEmail(txtEMailAddress, "The Email Address is not valid") == true) { tab.SelectTab(0); return; } }

            if (cls_UTILITY.checkComboBox(cboIdentification, "Please select the identification type") == true) { tab.SelectTab(1); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtIDNo, "Please enter the I.D No") == true) { tab.SelectTab(1); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtIssuedAt, "Please enter where the identification is issued") == true) { tab.SelectTab(1); return; }

            if (cls_UTILITY.checkEmptyTextBox(txtAccountName, "Please enter the account name") == true) { tab.SelectTab(2); return; }
            if (cls_UTILITY.checkComboBox(cboAccountType, "Please select the account type") == true) { tab.SelectTab(2); return; }
            if (cls_UTILITY.checkComboBox(cboCurrencyType, "Please select the currency type") == true) { tab.SelectTab(2); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtInitialDeposit, "Please enter the initial deposit") == true) { tab.SelectTab(2); return; }

            if(cls_UTILITY.checkImage(AccountHolderPicture,"Please select the customer picture before saving")==true){return;}
            if (cls_UTILITY.checkImage(AccountHolderDigitalSign, "Please select the customer signature before saving") == true) { return; }

            cls_BANK_ACCOUNTS_obj.IntAccountID=intNewAccountID;
            cls_BANK_ACCOUNTS_obj.IntHolderType = intCustomerTypeID ;
            cls_BANK_ACCOUNTS_obj.StrSurname= txtSurname.Text  ;
            cls_BANK_ACCOUNTS_obj.StrOtherNames = txtOtherNames.Text;
            cls_BANK_ACCOUNTS_obj.StrMaidenName =txtMaidenName.Text  ;
            cls_BANK_ACCOUNTS_obj.IntTitleID = intTitleID;
            cls_BANK_ACCOUNTS_obj.IntGender = intGenderID;
            cls_BANK_ACCOUNTS_obj.DtdateOfBirth = dtpDateOfBirth.Value  ;
            cls_BANK_ACCOUNTS_obj.StrPlaceOfBirth = txtPlaceOfBirth.Text;
            cls_BANK_ACCOUNTS_obj.StrOccupation = txtOccupation.Text;
            cls_BANK_ACCOUNTS_obj.StrEmployer = txtEmployer.Text  ;
            cls_BANK_ACCOUNTS_obj.StrOfficePhone = txtOfficePhone.Text;
            cls_BANK_ACCOUNTS_obj.StrHomePhone = txtHomePhone.Text ;
            cls_BANK_ACCOUNTS_obj.StrMobilePhone = txtMobilePhone.Text;
            cls_BANK_ACCOUNTS_obj.StrPOBox = txtPOBox.Text  ;
            cls_BANK_ACCOUNTS_obj.StrEmail = txtEMailAddress.Text;
            cls_BANK_ACCOUNTS_obj.StrNationality = txtNationality.Text  ;

            if (strPictureName == null || strPictureName=="")
            {cls_BANK_ACCOUNTS_obj.StrPicture = strCurrentPictureName;}
            else
            {
                cls_BANK_ACCOUNTS_obj.StrPicture = strPictureName;
                if (cls_UTILITY.CopyImage(strPictureSource, cls_GLOBAL_VARIABLES.strPictureDestination, strPictureName) == false)
                {
                    cls_UTILITY.displayMessage("The picture already exists. Kindly change it", MessageBoxIcon.Exclamation);
                    return;
                }
            }

            if (strDigitalSignName == null || strDigitalSignName=="")
            {cls_BANK_ACCOUNTS_obj.StrDigitalSign = strCurrentSignName;}
            else
            {
                cls_BANK_ACCOUNTS_obj.StrDigitalSign = strDigitalSignName;
                if (cls_UTILITY.CopyImage(strDigitalSignSource, cls_GLOBAL_VARIABLES.strPictureDestination, strDigitalSignName) == false)
                {
                    cls_UTILITY.displayMessage("The signature already exists. Kindly change it", MessageBoxIcon.Exclamation);
                    return;
                }
            }

            cls_BANK_ACCOUNTS_obj.IntIdentificationDetailsID=intIdentificationDetailID;
            cls_BANK_ACCOUNTS_obj.IntIdentificationDetailID=intIdentificationDetailID;

            cls_BANK_ACCOUNTS_obj.IntIdentificationTypeID = intIdentificationID;
            cls_BANK_ACCOUNTS_obj.StrIdentificationNo = txtIDNo.Text  ;
            cls_BANK_ACCOUNTS_obj.DtDateIssued = dtpDateIssued.Value  ;
            cls_BANK_ACCOUNTS_obj.StrIssuedAt = txtIssuedAt.Text ;
            cls_BANK_ACCOUNTS_obj.StrIssuedBy = txtIssuedBy.Text ;
            cls_BANK_ACCOUNTS_obj.StrResidencePermitNo = txtResidencePermitNo.Text ;

            cls_BANK_ACCOUNTS_obj.StrAccountNo = lblAccountNo.Text;
            cls_BANK_ACCOUNTS_obj.StrAccountName = txtAccountName.Text ;
            cls_BANK_ACCOUNTS_obj.IntAccountType = intAccountTypeID;
            cls_BANK_ACCOUNTS_obj.IntCurrencyType = intCurrencyID;
            cls_BANK_ACCOUNTS_obj.StrInitialDeposit = txtInitialDeposit.Text ;
            if (blAdd == true) { cls_BANK_ACCOUNTS_obj.StrBalance = txtInitialDeposit.Text; }
            else { cls_BANK_ACCOUNTS_obj.StrBalance = lblBalance.Text; }
            
            cls_BANK_ACCOUNTS_obj.DtDateOpened = dtpDateOpened.Value ;

            cls_BANK_ACCOUNTS_obj.StrATMCardNo = lblATMCardNo.Text;
            cls_BANK_ACCOUNTS_obj.DtATMIssuedDate = dtpATMDateIssued.Value ;
            cls_BANK_ACCOUNTS_obj.DtATMExpiryDate = dtpATMExpiryDate.Value ;
            cls_BANK_ACCOUNTS_obj.StrATMAccessCode = txtATMAccesCode.Text;


            if (blAdd == true && blEdit == false)
            {
                
                if (cls_BANK_ACCOUNTS_obj.saveAll() == 1)
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    disableCtl();
                    disableFields();
                    fillComboBoxes();
                    strPictureName = "";
                    strDigitalSignName = "";
                    //loadAccountDetails(intAccountID);
                }
                else
                {
                    cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
                }
            }

            else if (blAdd == false && blEdit == true)
            {
                cls_BANK_ACCOUNTS_obj.IntAccountID = intAccountID;
                if (cls_BANK_ACCOUNTS_obj.updateAll() == 1)
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    disableCtl();
                    disableFields();
                    fillComboBoxes();
                    strPictureName = "";
                    strDigitalSignName = "";
                    loadAccountDetails(intAccountID);
                }
                else
                {
                    cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
                }
            }


        }

        private void cboAccounts_KeyPress(object sender, KeyPressEventArgs e) { e.Handled = true; }

        private void cboCustomerType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboCustomerType.SelectedItem;
                intCustomerTypeID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void cboTitle_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboTitle.SelectedItem;
                intTitleID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void cboGender_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboGender.SelectedItem;
                intGenderID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void cboIdentification_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboIdentification.SelectedItem;
                intIdentificationID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void cboAccountType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccountType.SelectedItem;
                intAccountTypeID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void cboCurrencyType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboCurrencyType.SelectedItem;
                intCurrencyID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception) { }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnBrowsePicture_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();

            openFileDialog.InitialDirectory = "C:/";
            openFileDialog.Filter = "All Files|*.*|Bitmaps|*.bmp|GIFs|*.gif|JPEGs|*.jpg";
            openFileDialog.FilterIndex = 2;

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                AccountHolderPicture.Image = Image.FromFile(openFileDialog.FileName);
                AccountHolderPicture.SizeMode = PictureBoxSizeMode.StretchImage;
                AccountHolderPicture.BorderStyle = BorderStyle.Fixed3D;
                strPictureSource = openFileDialog.FileName;
                string[] strPicturename = strPictureSource.Split('\\');
                strPictureName = strPicturename[strPicturename.Length - 1].ToString();
                strPictureExtension = new FileInfo(openFileDialog.FileName).Extension;
            }

        }

        private void btnBrowseCustomerType_Click(object sender, EventArgs e)
        {
            int_frm_CUSTOMER_TYPE_ID = 1;
            frm_CUSTOMER_TYPES frm_CUSTOMER_TYPES_obj = new frm_CUSTOMER_TYPES();
            frm_CUSTOMER_TYPES_obj.ShowDialog();
        }

        private void btnBrowseTitle_Click(object sender, EventArgs e)
        {
            int_frm_TITLE_TYPE_ID = 1;
            frm_TITLE_TYPES frm_TITLE_TYPES_obj = new frm_TITLE_TYPES();
            frm_TITLE_TYPES_obj.ShowDialog();
        }

        private void btnBrowseIdentification_Click(object sender, EventArgs e)
        {
            int_frm_IDENTIFICATION_TYPE_ID = 1;
            frm_IDENTIFICATION_TYPES frm_IDENTIFICATION_TYPES_obj = new frm_IDENTIFICATION_TYPES();
            frm_IDENTIFICATION_TYPES_obj.ShowDialog();
        }

        private void btnBrowseAccountType_Click(object sender, EventArgs e)
        {
            int_frm_ACCOUNT_TYPE_ID = 1;
            frm_ACCOUNT_TYPES frm_ACCOUNT_TYPES_obj = new frm_ACCOUNT_TYPES();
            frm_ACCOUNT_TYPES_obj.ShowDialog();
        }

        private void btnCurrencyType_Click(object sender, EventArgs e)
        {
            int_frm_CURRENCY_TYPE_ID = 1;
            frm_CURRENCY_TYPES frm_CURRENCY_TYPES_obj = new frm_CURRENCY_TYPES();
            frm_CURRENCY_TYPES_obj.ShowDialog();
        }

        private void btnBrowseSignature_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();

            openFileDialog.InitialDirectory = "C:/";
            openFileDialog.Filter = "All Files|*.*|Bitmaps|*.bmp|GIFs|*.gif|JPEGs|*.jpg";
            openFileDialog.FilterIndex = 2;

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                AccountHolderDigitalSign.Image = Image.FromFile(openFileDialog.FileName);
                AccountHolderDigitalSign.SizeMode = PictureBoxSizeMode.StretchImage;
                AccountHolderDigitalSign.BorderStyle = BorderStyle.Fixed3D;
                strDigitalSignSource = openFileDialog.FileName;
                string[] strDigitalSignname = strDigitalSignSource.Split('\\');
                strDigitalSignName = strDigitalSignname[strDigitalSignname.Length - 1].ToString();
                strDigitalSignExtension = new FileInfo(openFileDialog.FileName).Extension;
            }
        }

        private void btnRemovePicture_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.displayMessage("Are you sure you want to remove picture?") == true)
            {
                //if (cls_BANK_ACCOUNTS.deletePicture(intAccountID) <= 0)
                //{
                    AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp");
                    cls_UTILITY.DeleteImage(cls_GLOBAL_VARIABLES.strPictureDestination, strCurrentPictureName); 
                //}
                //else
                //{

                //}
            }
        }

        private void dtpDateOfBirth_ValueChanged(object sender, EventArgs e)
        {
            
        }

        private void dtpATMExpiryDate_ValueChanged(object sender, EventArgs e)
        {

        }

    }
}