/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;

using BMS.CLASSES;
using Fireball.Docking;


namespace BMS.FORMS
{
    public partial class frm_BANK_ACCOUNT_SEARCH : DockableWindow
    {

        string strSeach;
        int intAccountTypeID;
        int intCurrencyTypeID;
        int intAccountID;

        public frm_BANK_ACCOUNT_SEARCH()
        {
            InitializeComponent();
        }

        private void frm_BANK_ACCOUNT_SEARCH_Load(object sender, EventArgs e)
        {
            reset();
            fillComboBoxes();
        }

        private void fillComboBoxes()
        {
            cls_ACCOUNT_TYPES.loadAccountTypes(cboAccountType);
            cls_CURRENCY_TYPES.loadCurrency(cboCurrencyType);
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            strSeach = string.Empty;

            if (txtAccountNo.Text.Trim() != "")
            {
                if (strSeach == ""){strSeach = strSeach + " AccountNumber = '" + txtAccountNo.Text.Trim() + "'";}
                else{strSeach = strSeach + " AND AccountNumber = '" + txtAccountNo.Text.Trim() + "'";}
            }

            if (txtAccountName.Text.Trim() != "")
            {
                if (strSeach == ""){strSeach = strSeach + " AccountName = '" + txtAccountName.Text.Trim() + "'";}
                else{strSeach = strSeach + " AND AccountName = '" + txtAccountName.Text.Trim() + "'";}
            }

            if (intAccountTypeID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " AccountTypeID = " + intAccountTypeID; }
                else { strSeach = strSeach + " AND AccountTypeID = " + intAccountTypeID; }
            }

            if (intCurrencyTypeID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " CurrencyType = " + intCurrencyTypeID; }
                else { strSeach = strSeach + " AND CurrencyType = " + intCurrencyTypeID; }
            }

            if (txtInitialDeposit.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " InitialDeposit = '" + txtInitialDeposit.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND InitialDeposit = '" + txtInitialDeposit.Text.Trim() + "'"; }
            }

            if (txtBalance.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Balance = '" + txtBalance.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Balance = '" + txtBalance.Text.Trim() + "'"; }
            }

            if (dtpFromDateOpened.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " DateOpened >= #" + dtpFromDateOpened.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND DateOpened >= #" + dtpFromDateOpened.Value.ToShortDateString() + "#"; }
            }

            if (dtpToDateOpened.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " DateOpened <= #" + dtpToDateOpened.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND DateOpened <= #" + dtpToDateOpened.Value.ToShortDateString() + "#"; }
            }

            if (txtATMCardNo.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " ATMCardNumber = '" + txtATMCardNo.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND ATMCardNumber = '" + txtATMCardNo.Text.Trim() + "'"; }
            }

            if (dtpFromATMDateIssued.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " ATMDateIssued >= #" + dtpFromATMDateIssued.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND ATMDateIssued >= #" + dtpFromATMDateIssued.Value.ToShortDateString() + "#"; }
            }

            if (dtpToATMDateIssued.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " ATMDateIssued <= #" + dtpToATMDateIssued.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND ATMDateIssued <= #" + dtpToATMDateIssued.Value.ToShortDateString() + "#"; }
            }

            if (txtATMAccesCode.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " ATMAccessCode = '" + txtATMAccesCode.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND ATMAccessCode = '" + txtATMAccesCode.Text.Trim() + "'"; }
            }

            if (dtpFromExpiryDate.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " ATMExpiryDate >= #" + dtpFromExpiryDate.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND ATMExpiryDate >= #" + dtpFromExpiryDate.Value.ToShortDateString() + "#"; }
            }

            if (dtpToExpiryDate.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " ATMExpiryDate <= #" + dtpToExpiryDate.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND ATMExpiryDate <= #" + dtpToExpiryDate.Value.ToShortDateString() + "#"; }
            }

            if (strSeach != string.Empty)
            {
                cls_BANK_ACCOUNTS.searchAccountDetails(lvwAccountDetails, strSeach);
                lblNoRecord.Text = lvwAccountDetails.Items.Count + " Records Found";
            }
        }

        private void cboAccountType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboAccountType.SelectedItem;
                intAccountTypeID = lstItem.ListID;
            }catch (Exception Exc){}
        }

        private void cboCurrencyType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboCurrencyType.SelectedItem;
                intCurrencyTypeID = lstItem.ListID;
            }catch (Exception Exc) { }
        }

        private void reset()
        {
            cls_UTILITY.ClearFields(grpBoxAccountDetails);
            cls_UTILITY.ClearFields(grpBoxATMDetails);
            cls_UTILITY.ClearFields(grpBoxResult);
            dtpFromATMDateIssued.Checked = false;
            dtpToATMDateIssued.Checked = false;
            dtpFromExpiryDate.Checked = false;
            dtpToExpiryDate.Checked = false;
            dtpFromDateOpened.Checked = false;
            dtpToDateOpened.Checked = false;
            lvwAccountDetails.Items.Clear();
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            reset();
        }

        private void btnPreviewAll_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.intAccountID = 0;
            frm_REPORT_VIEWER.blAccount = true;
            frm_REPORT_VIEWER.strSQL  =  strSeach;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void btnPreviewSelected_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.intAccountID = 0;
            frm_REPORT_VIEWER.blAccount = true;
            frm_REPORT_VIEWER.intAccountID = intAccountID ;
            frm_REPORT_VIEWER.strSQL = strSeach ;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void lvwAccountDetails_Click(object sender, EventArgs e)
        {
            intAccountID = Convert.ToInt32(lvwAccountDetails.Items[lvwAccountDetails.FocusedItem.Index].SubItems[0].Text);
        }



    }
}