/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_BANK_BRANCHES : DockableWindow
    {

        int intBankBranchID=0;
        cls_BANK_BRANCHES cls_BANK_BRANCHES_obj = new cls_BANK_BRANCHES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_BANK_BRANCHES()
        {
            InitializeComponent();
        }

        private void frm_BANK_BRANCHES_Load(object sender, EventArgs e)
        {
            cls_BANK_BRANCHES.loadBankBranches(cboBankBranches);
            cls_BANK_BRANCHES.loadLogo();
            if (cls_BANK_BRANCHES.StrPicture == null) { picLogo.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoLogo.bmp"); }
            else { picLogo.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_BRANCHES.StrPicture); }
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboBankBranches_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboBankBranches.SelectedItem;
            intBankBranchID = cls_LIST_ITEM_obj.ListID;
            loadBankBranchesDetails(intBankBranchID);
        }

        private void loadBankBranchesDetails(int intBankBranchID)
        {
            cls_BANK_BRANCHES_obj.loadBankBranchesDetails(intBankBranchID);

            txtBranchNo.Text = cls_BANK_BRANCHES_obj.StrBranchNo;
            txtBranchName.Text = cls_BANK_BRANCHES_obj.StrBranchName;
            txtAddress.Text = cls_BANK_BRANCHES_obj.StrAddress;
            txtWebSite.Text = cls_BANK_BRANCHES_obj.StrWebSite;
            txtEMail.Text = cls_BANK_BRANCHES_obj.StrEMail;
            txtPhoneNo1.Text = cls_BANK_BRANCHES_obj.StrPhone1;
            txtPhoneNo2.Text = cls_BANK_BRANCHES_obj.StrPhone2;
            txtPhoneNo3.Text = cls_BANK_BRANCHES_obj.StrPhone3;
            txtFaxNo1.Text = cls_BANK_BRANCHES_obj.StrFax1;
            txtFaxNo2.Text = cls_BANK_BRANCHES_obj.StrFax2;
            txtFaxNo3.Text = cls_BANK_BRANCHES_obj.StrFax3;
            txtPOBx.Text = cls_BANK_BRANCHES_obj.StrPOBox;
            txtCity.Text = cls_BANK_BRANCHES_obj.StrPOBox;
            txtCountry.Text = cls_BANK_BRANCHES_obj.StrCountry;
            txtLocation.Text = cls_BANK_BRANCHES_obj.StrLocation;




        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboBankBranches.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboBankBranches.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
            txtBranchNo.Text = cls_BANK_BRANCHES.AutoGenNo();
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intBankBranchID == 0 || txtBranchNo.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the branch to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtBranchName, "Please enter the branch name") == true) {enableCtl(); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtPhoneNo1, "Please enter the phone no") == true) { enableCtl(); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtLocation, "Please enter the location name") == true) { enableCtl(); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtCity, "Please enter the city name") == true) { enableCtl(); return; }
            if (cls_UTILITY.checkEmptyTextBox(txtLocation, "Please enter the location name") == true) { enableCtl(); return; }

            cls_BANK_BRANCHES_obj.IntBankID = 1;
            cls_BANK_BRANCHES_obj.StrBranchNo  = txtBranchNo.Text.Trim();
            cls_BANK_BRANCHES_obj.StrBranchName  = txtBranchName .Text.Trim();
            cls_BANK_BRANCHES_obj.StrPhone1  = txtPhoneNo1.Text.Trim();
            cls_BANK_BRANCHES_obj.StrPhone2 = txtPhoneNo2.Text.Trim();
            cls_BANK_BRANCHES_obj.StrPhone3 = txtPhoneNo3.Text.Trim();
            cls_BANK_BRANCHES_obj.StrFax1 = txtFaxNo1.Text.Trim();
            cls_BANK_BRANCHES_obj.StrFax2 = txtFaxNo2.Text.Trim();
            cls_BANK_BRANCHES_obj.StrFax3 = txtFaxNo3.Text.Trim();
            cls_BANK_BRANCHES_obj.StrPOBox = txtPOBx.Text.Trim();
            cls_BANK_BRANCHES_obj.StrEMail = txtEMail.Text.Trim();
            cls_BANK_BRANCHES_obj.StrWebSite = txtWebSite.Text.Trim();
            cls_BANK_BRANCHES_obj.StrLocation = txtLocation.Text.Trim();
            cls_BANK_BRANCHES_obj.StrCity = txtCity.Text.Trim();
            cls_BANK_BRANCHES_obj.StrCountry = txtCountry.Text.Trim();
            cls_BANK_BRANCHES_obj.StrAddress = txtAddress.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_BANK_BRANCHES_obj.saveBankBranchDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_BANK_BRANCHES.loadBankBranches(cboBankBranches );
                    cls_UTILITY.disableFields(grpBoxDetails);
                    disableCtl();
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_BANK_BRANCHES_obj.updateBankBranchDetails(intBankBranchID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_BANK_BRANCHES.loadBankBranches(cboBankBranches);
                    cls_UTILITY.disableFields(grpBoxDetails);
                    disableCtl();
                }
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intBankBranchID == 0 || txtBranchNo.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the branch to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the branch. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboBankBranches_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

    }
}