using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Collections;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_BANK_STATEMENTS : DockableWindow
    {

        private string strSeach;
        private int intAccountID = 0;
        private cls_BANK_STATEMENT cls_BANK_STATEMENT_obj = new cls_BANK_STATEMENT();

        cls_TRANSACTIONS cls_TRANSACTIONS_obj = new cls_TRANSACTIONS();

        public frm_BANK_STATEMENTS()
        {
            InitializeComponent();
        }

        private void frm_BANK_STATEMENTS_Load(object sender, EventArgs e)
        {
            reset();
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccountNo);
        }

        private void reset()
        {
            cls_UTILITY.ClearFields(grpBoxTransaction);
            lvwTransactions.Items.Clear();
            lblNoRecord.Text = "0 Record Found";
            lblTotalBalance.Text = "";
            lblTotalCredit.Text = "";
            lblTotalDebit.Text = "";
            lblInitialDeposit.Text = "";
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            search();
        }

        private void search()
        {
            strSeach = string.Empty;

            if (intAccountID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " FromAccountID = " + intAccountID; }
                else { strSeach = strSeach + " OR FromAccountID = " + intAccountID; }
            }

            if (intAccountID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " ToAccountID = " + intAccountID; }
                else { strSeach = strSeach + " OR ToAccountID = " + intAccountID; }
            }

            if (strSeach != string.Empty)
            {
                cls_TRANSACTIONS.searchBankStatement(lvwTransactions, strSeach, intAccountID );
                lblNoRecord.Text = lvwTransactions.Items.Count + " Records Found";
                lblInitialDeposit.Text = cls_BANK_ACCOUNTS.loadInitialDeposit(intAccountID);
            }
            else { lvwTransactions.Items.Clear(); }

            getTotalAmount();

        }

        private void getTotalAmount()
        {
            int intCount = lvwTransactions.Items.Count;
            long lngTotalDebit = 0;
            long lngTotalCredit = 0;
            long lngTotalAmount=0;
            for (int x = 0; x < intCount; x++)
            {
                lngTotalDebit = lngTotalDebit + Convert.ToInt64(lvwTransactions.Items[x].SubItems[3].Text);
                lngTotalCredit = lngTotalCredit + Convert.ToInt64(lvwTransactions.Items[x].SubItems[4].Text);
            }
            lblTotalDebit.Text = lngTotalDebit.ToString();
            lblTotalCredit.Text = lngTotalCredit.ToString();

            if(lblInitialDeposit.Text=="")
            {
                lngTotalAmount =  lngTotalDebit + lngTotalCredit;
            }
            else
            {
                lngTotalAmount = Convert.ToInt64(lblInitialDeposit.Text) - lngTotalDebit + lngTotalCredit;
            }

            lblTotalBalance.Text = lngTotalAmount.ToString();

        }

        private void cboAccountNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboAccountNo.SelectedItem;
                intAccountID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            reset();
        }

        private void btnPreviewSelected_Click(object sender, EventArgs e)
        {
            cls_BANK_STATEMENT_obj.IntAccountID = intAccountID;
            cls_BANK_STATEMENT_obj.StrAccountNo = cboAccountNo.Text.Trim();
            cls_BANK_STATEMENT_obj.FlInitialDeposit = Convert.ToSingle(lblInitialDeposit.Text);

            if (cls_BANK_STATEMENT_obj.saveBankStatement() != 1)
            {
                { 
                    cls_UTILITY.displayMessage("An error occured while loading report. Please retry", MessageBoxIcon.Error); 
                }
            }
            else
            {
                foreach (ListViewItem lvwItem in lvwTransactions.Items)
                {
                    cls_BANK_STATEMENT_obj.DtTransactionDate = DateTime.Parse(lvwItem.SubItems[1].Text);
                    cls_BANK_STATEMENT_obj.StrTransactionType = lvwItem.SubItems[2].Text;
                    cls_BANK_STATEMENT_obj.FlDebit = Convert.ToSingle ( lvwItem.SubItems[3].Text);
                    cls_BANK_STATEMENT_obj.FlCredit = Convert.ToSingle(lvwItem.SubItems[4].Text);

                    cls_BANK_STATEMENT_obj.saveBankStatementDetails();
                }
                loadReport();
            }
           

        }

        private void loadReport()
        {
            frm_REPORT_VIEWER.blBankStatement = true;
            frm_REPORT_VIEWER.strSQL = "SELECT * FROM vw_BANK_STATEMENT WHERE AccountID=" + intAccountID ;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

    }
}