/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using BMS.CLASSES;
using Fireball.Docking;
namespace BMS.FORMS
{
    public partial class frm_CASH_DEPOSIT : DockableWindow
    {

        private int intAccountID;
        private int IntStatus = 0;
        cls_UTILITY cls_UTILITY_obj = new cls_UTILITY();
        cls_BANK_ACCOUNTS cls_BANK_ACCOUNTS_obj = new cls_BANK_ACCOUNTS();
        cls_TRANSACTIONS cls_TRANSACTIONS_obj = new cls_TRANSACTIONS();
        
        public frm_CASH_DEPOSIT()
        {
            InitializeComponent();
        }

        private void frm_CASH_DEPOSIT_Load(object sender, EventArgs e)
        {
            //disableCtl();
            cls_UTILITY.disableFields(grpBoxTransactionDetails);
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccounts);
        }

        private void disableCtl()
        {
            btnClose.Enabled = true;

            cboAccounts.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnClose.Enabled = false;

            cboAccounts.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void cboAccounts_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_UTILITY.ClearFields(grpBoxTransactionDetails);
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccounts.SelectedItem;
                intAccountID = cls_LIST_ITEM_obj.ListID;
                loadAccountDetails(intAccountID);
                lblAlerte.Text = "The fields with (*) are compulsory";
            }
            catch (Exception ex) { }
        }

        private void loadAccountDetails(int intAccountID)
        {
            cls_BANK_ACCOUNTS_obj.loadAccountDetails(intAccountID);


            lblFullName.Text = cls_BANK_ACCOUNTS_obj.StrTitleShortName + " " + cls_BANK_ACCOUNTS_obj.StrSurname + " " + cls_BANK_ACCOUNTS_obj.StrOtherNames + " " + cls_BANK_ACCOUNTS_obj.StrMaidenName;
            lblGender.Text = cls_BANK_ACCOUNTS_obj.StrGender;
            lblOfficePhone.Text = cls_BANK_ACCOUNTS_obj.StrOfficePhone;
            lblHomePhone.Text = cls_BANK_ACCOUNTS_obj.StrHomePhone;
            lblEMailAddress.Text = cls_BANK_ACCOUNTS_obj.StrEmail;
            lblPOBox.Text = cls_BANK_ACCOUNTS_obj.StrPOBox;
            lblAccountNo.Text = cls_BANK_ACCOUNTS_obj.StrAccountNo;
            lblAccountName.Text = cls_BANK_ACCOUNTS_obj.StrAccountName;
            lblAccountType.Text = cls_BANK_ACCOUNTS_obj.StrAccountType;
            lblCurrencyType.Text = cls_BANK_ACCOUNTS_obj.StrCurrencyType;
            if (cls_BANK_ACCOUNTS_obj.StrBalance == ""){lblBalance.Text =(0).ToString();}
            else{lblBalance.Text = cls_BANK_ACCOUNTS_obj.StrBalance;}
            lblDateOpened.Text = cls_BANK_ACCOUNTS_obj.DtDateOpened.ToString();

            if (cls_BANK_ACCOUNTS_obj.StrPicture == "") { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp"); }
            else { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrPicture); }

            if (cls_BANK_ACCOUNTS_obj.StrDigitalSign == "") { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoSignature.bmp"); }
            else { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrDigitalSign); }

        }

        private void txtAmount_TextChanged(object sender, EventArgs e)
        {
            if (txtAmount.Text == "")
            {
                lblAmountInWords.Text = "";
                lblTotalBalance.Text = "";
                return;
            }
            else
            {
                lblAmountInWords.Text = cls_UTILITY_obj.IntegerToWords(Convert.ToInt64(txtAmount.Text));
                long lngTotal = Convert.ToInt64(lblBalance.Text) + Convert.ToInt64(txtAmount.Text);
                lblTotalBalance.Text = lngTotal.ToString();
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtAmount, "Please enter the amount deposited") == true) { return; }
            if (cls_UTILITY.checkEmptyTextBox(txtDepositedBy, "Please enter the name of the person who deposited the money") == true) { return; }

            cls_TRANSACTIONS_obj.IntTransactionID = cls_TRANSACTIONS.AutogenID();
            cls_TRANSACTIONS_obj.DtTransactionDate = DateTime.Today;
            cls_TRANSACTIONS_obj.IntTransactionTypeID = 1;//1 means Cash Deposit
            cls_TRANSACTIONS_obj.StrTransactionMode = "Cash Deposit";
            cls_TRANSACTIONS_obj.IntFromAccountID = 0;
            cls_TRANSACTIONS_obj.StrFromAccountNo = "";
            cls_TRANSACTIONS_obj.IntToAccountID = intAccountID ;
            cls_TRANSACTIONS_obj.StrToAccountNo = lblAccountNo.Text.Trim() ;
            cls_TRANSACTIONS_obj.StrChequeNumber = "";
            cls_TRANSACTIONS_obj.LngAmount = Convert.ToInt64(txtAmount.Text);
            cls_TRANSACTIONS_obj.IntStatus = IntStatus;
            cls_TRANSACTIONS_obj.StrDepositedBy = txtDepositedBy.Text.Trim();
            cls_TRANSACTIONS_obj.LngTotalBalance = Convert.ToInt64(lblTotalBalance.Text);

            if (cls_TRANSACTIONS_obj.saveTransactions() == 0)
            {
                cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
            }
            else
            {
                if (IntStatus == 1)
                {
                    if (cls_TRANSACTIONS_obj.updateBalance(intAccountID) == 0)
                    {
                        cls_UTILITY.displayMessage("An error occured while updating balance. Please retry", MessageBoxIcon.Error);
                    }
                }

                cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                loadAccountDetails(intAccountID);
                cls_UTILITY.ClearFields(grpBoxTransactionDetails);
                cls_UTILITY.disableFields(grpBoxTransactionDetails);
                btnCancel.Enabled = false ;
                btnSave.Enabled = false ;
                btnNewCashDeposit.Enabled = true;
                cboAccounts.Enabled = true ;
            }

        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            cls_UTILITY.ClearFields(grpBoxTransactionDetails);
            cboAccounts.Enabled = true;
            btnCancel.Enabled = false;
            btnSave.Enabled = false ;
            btnNewCashDeposit.Enabled = true ;
            cls_UTILITY.disableFields(grpBoxTransactionDetails);
        }

        private void chkStatus_CheckedChanged(object sender, EventArgs e)
        {
            if (chkStatus.Checked == true)
            {
                IntStatus = 1;
                chkStatus.BackColor = Color.Red;
                chkStatus.Text = "Posted";
            }
            else
            {
                IntStatus = 0;
                chkStatus.BackColor = Color.Green;
                chkStatus.Text = "Pending";
            }
        }

        private void btnNewCashDeposit_Click(object sender, EventArgs e)
        {
            if (intAccountID == 0)
            {
                cls_UTILITY.displayMessage("Please select account no",MessageBoxIcon.Exclamation );
            }
            else
            {
                btnCancel.Enabled = true;
                btnSave.Enabled = true;
                btnNewCashDeposit.Enabled = false;
                cboAccounts.Enabled = false;
                cls_UTILITY.enableFields(grpBoxTransactionDetails);
            }
        }




    }
}