/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_CHANGE_PASSWORD : Form
    {
        cls_USERS cls_USERS_OBJ = new cls_USERS();
        public int intUserID;

        public frm_CHANGE_PASSWORD(){InitializeComponent();}

        private void btnClose_Click(object sender, EventArgs e){Close();}

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtCurrentPassword, "Please enter the current password") == true ) { return ; }
            if (cls_UTILITY.checkEmptyTextBox(txtNewPassword, "Please enter the new password") == true ) { return; }
            if (cls_UTILITY.checkEmptyTextBox(txtConfirmNewPassword, "Please confirm the new password") == true ) { return; }

            
            cls_USERS_OBJ.StrUserName = txtUserName.Text.Trim();
            cls_USERS_OBJ.StrPassword = txtCurrentPassword.Text.Trim();
            cls_USERS_OBJ.StrNewPassword = txtNewPassword.Text.Trim();
            

            if (txtNewPassword.Text.Trim() == txtConfirmNewPassword.Text.Trim())
            {
                if (cls_USERS_OBJ.CheckUserLogin() == false) { cls_UTILITY.displayMessage("Invalid User", MessageBoxIcon.Error); }
                else
                {
                    if (cls_USERS_OBJ.updateUserPassword(Convert.ToInt32(lblUserID.Text)) == 0) { cls_UTILITY.displayMessage("Password could not be changed. Please retry.", MessageBoxIcon.Error); }
                    else 
                    { 
                        cls_UTILITY.displayMessage("Password changed successfully.", MessageBoxIcon.Exclamation);
                        this.Close();

                        frm_LOGIN frm_LOGIN_obj = new frm_LOGIN();
                        frm_LOGIN_obj.ShowDialog();
                    }
                }
            }
            else{cls_UTILITY.displayMessage("The new passwords are not the same. Please retry.", MessageBoxIcon.Error);}
        }

        private void frm_CHANGE_PASSWORD_Load(object sender, EventArgs e)
        {
            txtUserName.Text = cls_GLOBAL_VARIABLES.strUserName;
            lblUserID.Text = cls_GLOBAL_VARIABLES.intUserID.ToString();
        }

        private void frm_CHANGE_PASSWORD_FormClosed(object sender, FormClosedEventArgs e)
        {

        }
    }
}