/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using Fireball.Docking;

using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_CHEQUE_BOOK : DockableWindow
    {
        int intChequeBookID;
        int intAccountID;
        cls_CHEQUE_BOOK cls_CHEQUE_BOOK_obj = new cls_CHEQUE_BOOK();
        cls_UTILITY cls_UTILITY_obj = new cls_UTILITY();
        public frm_CHEQUE_BOOK()
        {
            InitializeComponent();
        }

        private void frm_CHEQUE_BOOK_Load(object sender, EventArgs e)
        {
            cls_CHEQUE_BOOK.loadChequeBooks(cboChequeBookNo );
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccountNo);
            lblNoOfCheques.Text = cls_OPTIONS.LoadProgramSettings().ToString();
            disableCtl();
            disableFields();
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnClose.Enabled = true;

            cboChequeBookNo.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnClose.Enabled = false;

            cboChequeBookNo.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void enableFields()
        {
            cls_UTILITY.enableFields(grpBoxChequeBook );
            cls_UTILITY.enableFields(grpBoxCheques );
        }

        private void disableFields()
        {
            cls_UTILITY.disableFields(grpBoxChequeBook);
            cls_UTILITY.disableFields(grpBoxCheques);
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            cls_UTILITY.ClearFields(grpBoxChequeBook);
            cls_UTILITY.ClearFields(grpBoxCheques);
            enableCtl();
            enableFields();

            lblChequeBookNo.Text = cls_CHEQUE_BOOK.AutoGenChequeBookNo();
            cls_CHEQUE_BOOK.AutoGenChequeNo(lvwCheque, Convert.ToInt16(lblNoOfCheques.Text));
            cls_CHEQUE_BOOK.loadAccountNo(cboAccountNo);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (lblChequeBookNo.Text == "") { cls_UTILITY.displayMessage("Please generate cheque book to save", MessageBoxIcon.Exclamation); return; }
            if (cls_UTILITY.checkComboBox(cboAccountNo, "Please select the account no") == true) { return; }

            cls_CHEQUE_BOOK_obj.IntChequeBookID = cls_CHEQUE_BOOK.AutogenID();
            cls_CHEQUE_BOOK_obj.StrChequeBookNo = lblChequeBookNo.Text;
            cls_CHEQUE_BOOK_obj.DtDateIssued = DateTime.Today ;
            cls_CHEQUE_BOOK_obj.IntAccountID = intAccountID;

            if (cls_CHEQUE_BOOK_obj.saveChequeBook() != 0)
            {
                for (int x = 0; x < lvwCheque.Items.Count; x++)
                {
                    cls_CHEQUE_BOOK_obj.StrChequeNo = lvwCheque.Items[x].Text;
                    cls_CHEQUE_BOOK_obj.saveCheque();
                }

                cls_UTILITY.displayMessage("Details Saved Successfully", MessageBoxIcon.Information);
                cls_BANK_ACCOUNTS.loadAccountNo(cboAccountNo);
                cls_CHEQUE_BOOK.loadChequeBooks(cboChequeBookNo);
                disableCtl();
                disableFields();

            }
            else
            {
                cls_UTILITY.displayMessage("Unable to save records. Try Again", MessageBoxIcon.Error);
            }
        }

        private void cboAccountNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccountNo.SelectedItem;
                intAccountID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception exc)
            {
            }
        }

        private void cboChequeBookNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboChequeBookNo.SelectedItem;
            intChequeBookID = cls_LIST_ITEM_obj.ListID;
            loadChequeBookDetails(intChequeBookID);
            cls_CHEQUE_BOOK_obj.loadCheques(lvwCheque, intChequeBookID);
        }

        private void loadChequeBookDetails(int intChequeBookID)
        {
            cls_CHEQUE_BOOK_obj.loadChequeBookDetails(intChequeBookID);
            
            lblChequeBookNo.Text = cls_CHEQUE_BOOK_obj.StrChequeBookNo;
            lblDateIssued.Text  = cls_CHEQUE_BOOK_obj.DtDateIssued.ToString();
            cls_UTILITY_obj.GetItem(cboAccountNo, cls_CHEQUE_BOOK_obj.IntAccountID);

        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccountNo);
            cls_CHEQUE_BOOK.loadChequeBooks(cboChequeBookNo);
            disableCtl();
            disableFields();
            lblChequeBookNo.Text = "";
            lblDateIssued.Text = "";
            lblNoOfCheques.Text = cls_OPTIONS.LoadProgramSettings().ToString();
            lvwCheque.Items.Clear();
        }

    }
}