/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_CURRENCY_TYPES : Form
    {

        int intCurrencyTypeID=0;
        cls_CURRENCY_TYPES cls_CURRENCY_TYPES_obj = new cls_CURRENCY_TYPES();
        bool blAdd=false ;
        bool blEdit=false ;

        public frm_CURRENCY_TYPES()
        {
            InitializeComponent();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frm_CURRENCY_TYPES_Load(object sender, EventArgs e)
        {
            cls_CURRENCY_TYPES.loadCurrency(cboCurrencyTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboCurrencyTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboCurrencyTypes.SelectedItem;
            intCurrencyTypeID = cls_LIST_ITEM_obj.ListID;
            loadCurrencyDetails(intCurrencyTypeID);
        }

        private void loadCurrencyDetails(int intCurrencyTypeID)
        {
            cls_CURRENCY_TYPES_obj.loadCurrencyDetails(intCurrencyTypeID);

            txtCurrencyName.Text = cls_CURRENCY_TYPES_obj.StrCurrencyName;
            txtCurrencySymbol.Text = cls_CURRENCY_TYPES_obj.StrCurrencySymbol;
            txtDescription.Text = cls_CURRENCY_TYPES_obj.StrDescription;
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboCurrencyTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false ;
            btnEdit.Enabled = false ;
            btnDelete.Enabled = false ;
            btnClose.Enabled = false ;

            cboCurrencyTypes.Enabled = false ;

            btnCancel.Enabled = true ;
            btnSave.Enabled = true ;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intCurrencyTypeID  == 0 || txtCurrencyName.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the currency type to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtCurrencyName, "Please enter the currency name") == false) { disableCtl(); }

            cls_CURRENCY_TYPES_obj.StrCurrencyName = txtCurrencyName.Text.Trim();
            cls_CURRENCY_TYPES_obj.StrCurrencySymbol = txtCurrencySymbol.Text.Trim();
            cls_CURRENCY_TYPES_obj.StrDescription = txtDescription.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_CURRENCY_TYPES_obj.saveCurrencyDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_CURRENCY_TYPES.loadCurrency(cboCurrencyTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_CURRENCY_TYPES_obj.updateCurrencyDetails(intCurrencyTypeID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_CURRENCY_TYPES.loadCurrency(cboCurrencyTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }

        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intCurrencyTypeID == 0 || txtCurrencyName.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the currency type to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the currency type. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboCurrencyTypes_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void frm_CURRENCY_TYPES_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (frm_BANK_ACCOUNTS.int_frm_CURRENCY_TYPE_ID == 1)
            {
                cls_CURRENCY_TYPES.loadCurrency(frm_BANK_ACCOUNTS.frm_BANK_ACCOUNTS_obj.cboCurrencyType);
            }
        }
    }
}