/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_CUSTOMER_QUERIES : DockableWindow
    {
        bool blAdd = false;
        bool blEdit = false;
        private int intAccountID;
        private int intCustomerQueryID;
        private int intStatus;
        cls_ACCOUNT_TYPES cls_ACCOUNT_TYPES_obj = new cls_ACCOUNT_TYPES();
        cls_BANK_ACCOUNTS cls_BANK_ACCOUNTS_obj = new cls_BANK_ACCOUNTS();
        cls_CUSTOMER_QUERIES cls_CUSTOMER_QUERIES_obj = new cls_CUSTOMER_QUERIES();

        public frm_CUSTOMER_QUERIES()
        {
            InitializeComponent();
        }

        private void frm_CUSTOMER_QUERIES_Load(object sender, EventArgs e)
        {
            disableCtl();
            disableFields();
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccounts);
        }

        private void cboQueries_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccounts.SelectedItem;
            intAccountID = cls_LIST_ITEM_obj.ListID;
            loadAccountDetails(intAccountID);
            loadCustomerQueries(intAccountID);
            cls_UTILITY.ClearFields(grpBoxQueries);
        }

        private void loadAccountDetails(int intAccountID)
        {
            cls_BANK_ACCOUNTS_obj.loadAccountDetails(intAccountID);


            lblFullName.Text = cls_BANK_ACCOUNTS_obj.StrTitleShortName  + " " + cls_BANK_ACCOUNTS_obj.StrSurname + " " + cls_BANK_ACCOUNTS_obj.StrOtherNames + " " + cls_BANK_ACCOUNTS_obj.StrMaidenName;
            lblGender.Text = cls_BANK_ACCOUNTS_obj.StrGender ;
            lblAccountName.Text = cls_BANK_ACCOUNTS_obj.StrAccountName;
            lblAccountType.Text =cls_BANK_ACCOUNTS_obj.StrAccountType;
            lblOfficePhone.Text = cls_BANK_ACCOUNTS_obj.StrOfficePhone;
            lblHomePhone.Text = cls_BANK_ACCOUNTS_obj.StrHomePhone;
            lblOfficePhone.Text = cls_BANK_ACCOUNTS_obj.StrOfficePhone;
            lblEMailAddress.Text = cls_BANK_ACCOUNTS_obj.StrEmail;
            lblPOBox.Text = cls_BANK_ACCOUNTS_obj.StrPOBox;
            lblBalance.Text = cls_BANK_ACCOUNTS_obj.StrBalance;
            lblDateOpened.Text  = cls_BANK_ACCOUNTS_obj.DtDateOpened.ToString();
            if (cls_BANK_ACCOUNTS_obj.StrPicture == "") { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp"); }
            else { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrPicture); }
        }

        private void loadCustomerQueries(int intAccountID)
        {
            cls_CUSTOMER_QUERIES.loadQueries(cboQueries, intAccountID);
        }

        private void cboQueries_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboQueries.SelectedItem;
            intCustomerQueryID = cls_LIST_ITEM_obj.ListID;
            loadCustomerQueryDetails(intCustomerQueryID);
        }

        private void loadCustomerQueryDetails(int intCustomerQueryID)
        {
            cls_CUSTOMER_QUERIES_obj.loadCustomerQueryDetails(intCustomerQueryID);

            lblQueryNo.Text = cls_CUSTOMER_QUERIES_obj.StrCustomerQueryNo;
            dtPDateReceived.Value  = cls_CUSTOMER_QUERIES_obj.DtDateRecived;
            txtQuery.Text = cls_CUSTOMER_QUERIES_obj.StrQuery;
            if (cls_CUSTOMER_QUERIES_obj.IntStatus == 0)
            {
                chkStatus.Checked  = true ;
                chkStatus.Text = "PENDING";
                chkStatus.BackColor = Color.Green;
            }
            else
            {
                chkStatus.Checked = false;
                chkStatus.Text = "SOLVED";
                chkStatus.BackColor = Color.Red ;
            }
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            if (lblFullName.Text == "")
            {
                cls_UTILITY.displayMessage("Please select the account no");
            }
            else
            {
                blAdd = true;
                blEdit = false;
                enableCtl();

                enableFields();
                cls_UTILITY.ClearFields(grpBoxQueries);

                lblQueryNo.Text = cls_CUSTOMER_QUERIES.AutoGenNo();
            }
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboAccounts.Enabled = true;
            cboQueries.Enabled = true ;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboAccounts.Enabled = false;
            cboQueries.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void enableFields()
        {
            cls_UTILITY.enableFields(grpBoxCustomerDetails);
            cls_UTILITY.enableFields(grpBoxQueries);
        }

        private void disableFields()
        {
            cls_UTILITY.disableFields(grpBoxCustomerDetails);
            cls_UTILITY.disableFields(grpBoxQueries);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intCustomerQueryID == 0 || lblQueryNo.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the query to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            enableFields();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intCustomerQueryID == 0 || lblQueryNo.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the query to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the customer query. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            disableFields();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            //disableCtl();
           
            if (cls_UTILITY.checkEmptyTextBox(txtQuery , "Please enter the Query") == true) { return; }

            cls_CUSTOMER_QUERIES_obj.IntAccountID = intAccountID;
            cls_CUSTOMER_QUERIES_obj.StrCustomerQueryNo = lblQueryNo.Text.Trim();
            cls_CUSTOMER_QUERIES_obj.StrQuery = txtQuery.Text.Trim();
            cls_CUSTOMER_QUERIES_obj.DtDateRecived = dtPDateReceived.Value;
            cls_CUSTOMER_QUERIES_obj.IntStatus = intStatus;


            if (blAdd == true && blEdit == false)
            {

                if (cls_CUSTOMER_QUERIES_obj.saveCustomerQuery() == 1)
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    disableCtl();
                    disableFields();
                }
                else
                {
                    cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
                }
            }

            else if (blAdd == false && blEdit == true)
            {

                if (cls_CUSTOMER_QUERIES_obj.updateCustomerQuery(intCustomerQueryID) == 1)
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    disableCtl();
                    disableFields();
                }
                else
                {
                    cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
                }
            }
        }

        private void chkStatus_CheckedChanged(object sender, EventArgs e)
        {
            if (chkStatus.Checked == true)
            {
                intStatus = 0;
                chkStatus.BackColor = Color.Green;
                chkStatus.Text = "PENDING";
            }
            else
            {
                intStatus = 1;
                chkStatus.BackColor = Color.Red ;
                chkStatus.Text = "SOLVED";
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}