/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_CUSTOMER_SEARCH : DockableWindow
    {
        string strSeach;
        int intCustomerTypeID = 0;
        int intTitleID = 0;
        int intGenderID = 0;
        int intCustomerID = 0;

        public frm_CUSTOMER_SEARCH()
        {
            InitializeComponent();
        }

        private void frm_CUSTOMER_SEARCH_Load(object sender, EventArgs e)
        {
            reset();
            fillComboBoxes();
        }

        private void fillComboBoxes()
        {
            cls_CUSTOMER_TYPES.loadCustomerTypes(cboCustomerType);
            cls_TITLE_TYPES.loadTitleTypes(cboTitle);
            cls_BANK_ACCOUNTS.loadGender(cboGender);

        }

        private void reset()
        {
            cls_UTILITY.ClearFields(grpBoxAccountHolderDetails);
            dtpFromDateOfBirth.Checked = false;
            dtpToDateOfBirth.Checked = false;
            lvwCustomerDetails.Items.Clear();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            strSeach = string.Empty;

            if (intCustomerTypeID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " HolderType = " + intCustomerTypeID; }
                else { strSeach = strSeach + " AND HolderType = " + intCustomerTypeID; }
            }

            if (txtSurname.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Surname = '" + txtSurname.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Surname = '" + txtSurname.Text.Trim() + "'"; }
            }

            if (txtOtherNames.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " OtherNames = '" + txtOtherNames.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND OtherNames = '" + txtOtherNames.Text.Trim() + "'"; }
            }

            if (txtMaidenName.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " MaidenName = '" + txtMaidenName.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND MaidenName = '" + txtMaidenName.Text.Trim() + "'"; }
            }

            if (intTitleID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " TitleID = " + intTitleID; }
                else { strSeach = strSeach + " AND TitleID = " + intTitleID; }
            }

            if (intGenderID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " GenderID = " + intGenderID; }
                else { strSeach = strSeach + " AND GenderID = " + intGenderID; }
            }

            if (dtpFromDateOfBirth.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " DateOfBirth >= #" + dtpFromDateOfBirth.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND DateOfBirth >= #" + dtpFromDateOfBirth.Value.ToShortDateString() + "#"; }
            }

            if (dtpToDateOfBirth.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " DateOfBirth <= #" + dtpToDateOfBirth.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND DateOfBirth <= #" + dtpToDateOfBirth.Value.ToShortDateString() + "#"; }
            }

            if (txtPlaceOfBirth.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " PlaceAndCountryOfBirth = '" + txtPlaceOfBirth.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND PlaceAndCountryOfBirth = '" + txtPlaceOfBirth.Text.Trim() + "'"; }
            }

            if (txtOccupation.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Occupation = '" + txtOccupation.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Occupation = '" + txtOccupation.Text.Trim() + "'"; }
            }

            if (txtEmployer.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Employer = '" + txtEmployer.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Employer = '" + txtEmployer.Text.Trim() + "'"; }
            }

            if (txtOfficePhone.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " OfficePhone = '" + txtOfficePhone.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND OfficePhone = '" + txtOfficePhone.Text.Trim() + "'"; }
            }

            if (txtHomePhone.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " HomePhone = '" + txtHomePhone.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND HomePhone = '" + txtHomePhone.Text.Trim() + "'"; }
            }

            if (txtMobilePhone.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " MobilePhone = '" + txtMobilePhone.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND MobilePhone = '" + txtMobilePhone.Text.Trim() + "'"; }
            }

            if (txtPOBox.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " POBox = '" + txtPOBox.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND POBox = '" + txtPOBox.Text.Trim() + "'"; }
            }

            if (txtEMailAddress.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " EMail = '" + txtEMailAddress.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND EMail = '" + txtEMailAddress.Text.Trim() + "'"; }
            }

            if (txtNationality.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Nationality = '" + txtNationality.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Nationality = '" + txtNationality.Text.Trim() + "'"; }
            }

            if (strSeach != string.Empty)
            {
                cls_BANK_ACCOUNTS.searchCustomerDetails(lvwCustomerDetails, strSeach);
                lblNoRecord.Text = lvwCustomerDetails.Items.Count + " Records Found";
            }
        }

        private void cboCustomerType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboCustomerType.SelectedItem;
                intCustomerTypeID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void cboTitle_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboTitle.SelectedItem;
                intTitleID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void cboGender_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboGender.SelectedItem;
                intGenderID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void btnPreviewAll_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.intCustomerID = 0;
            frm_REPORT_VIEWER.blCustomer = true;
            frm_REPORT_VIEWER.strSQL  =  strSeach;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void lvwCustomerDetails_Click(object sender, EventArgs e)
        {
            intCustomerID = Convert.ToInt32(lvwCustomerDetails.Items[lvwCustomerDetails.FocusedItem.Index].SubItems[0].Text);
        }

        private void btnPreviewSelected_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.intCustomerID = intCustomerID ;
            frm_REPORT_VIEWER.blCustomer = true;
            frm_REPORT_VIEWER.strSQL = strSeach;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            reset();
        }
    }
}