/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;
namespace BMS.FORMS
{
    public partial class frm_CUSTOMER_TYPES : Form
    {
        int intCustomerTypeID = 0;
        cls_CUSTOMER_TYPES cls_CUSTOMER_TYPES_obj = new cls_CUSTOMER_TYPES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_CUSTOMER_TYPES()
        {
            InitializeComponent();
        }

        private void frm_CUSTOMER_TYPES_Load(object sender, EventArgs e)
        {
            cls_CUSTOMER_TYPES.loadCustomerTypes(cboCustomerTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboCustomerTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboCustomerTypes.SelectedItem;
            intCustomerTypeID = cls_LIST_ITEM_obj.ListID;
            loadCustomerDetails(intCustomerTypeID);
        }

        private void loadCustomerDetails(int intCustomerTypeID)
        {
            cls_CUSTOMER_TYPES_obj.loadCustomerTypesDetails(intCustomerTypeID);

            txtCustomerType.Text = cls_CUSTOMER_TYPES_obj.StrCustomerType;
            txtDescription.Text = cls_CUSTOMER_TYPES_obj.StrDescription;
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboCustomerTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboCustomerTypes.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intCustomerTypeID == 0 || txtCustomerType.Text.Trim()==string.Empty ) { cls_UTILITY.displayMessage("Please select the customer type to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtCustomerType, "Please enter the customer type") == false) { disableCtl(); }

            cls_CUSTOMER_TYPES_obj.StrCustomerType = txtCustomerType.Text.Trim();
            cls_CUSTOMER_TYPES_obj.StrDescription = txtDescription.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_CUSTOMER_TYPES_obj.saveCustomerTypesDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_CUSTOMER_TYPES.loadCustomerTypes(cboCustomerTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_CUSTOMER_TYPES_obj.updateCustomerTypesDetails(intCustomerTypeID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_CUSTOMER_TYPES.loadCustomerTypes(cboCustomerTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intCustomerTypeID == 0 || txtCustomerType.Text.Trim()==string.Empty ) { cls_UTILITY.displayMessage("Please select the customer type to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the customer type. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboCustomerTypes_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void frm_CUSTOMER_TYPES_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (frm_BANK_ACCOUNTS.int_frm_CUSTOMER_TYPE_ID == 1)
            {
                cls_CUSTOMER_TYPES.loadCustomerTypes(frm_BANK_ACCOUNTS.frm_BANK_ACCOUNTS_obj.cboCustomerType);
            }
        }
    }
}