/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_IDENTIFICATION_TYPES : Form
    {
        int intIdentificationTypeID = 0;
        cls_IDENTIFICATION_TYPES cls_IDENTIFICATION_TYPES_obj = new cls_IDENTIFICATION_TYPES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_IDENTIFICATION_TYPES()
        {
            InitializeComponent();
        }

        private void frm_IDENTIFICATION_TYPES_Load(object sender, EventArgs e)
        {
            cls_IDENTIFICATION_TYPES.loadIdentificationType(cboIdentificationTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void cboIdentificationTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboIdentificationTypes.SelectedItem;
            intIdentificationTypeID = cls_LIST_ITEM_obj.ListID;
            loadIdentificationDetails(intIdentificationTypeID);
        }

        private void loadIdentificationDetails(int intCurrencyTypeID)
        {
            cls_IDENTIFICATION_TYPES_obj.loadIdentificationDetails(intCurrencyTypeID);

            txtIdentificationType.Text = cls_IDENTIFICATION_TYPES_obj.StrIdentificationType;
            txtDescription.Text = cls_IDENTIFICATION_TYPES_obj.StrDescription;
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboIdentificationTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboIdentificationTypes.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intIdentificationTypeID == 0 || txtIdentificationType.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the identification type to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtIdentificationType, "Please enter the identification type") == false) { disableCtl(); }

            cls_IDENTIFICATION_TYPES_obj.StrIdentificationType = txtIdentificationType.Text.Trim();
            cls_IDENTIFICATION_TYPES_obj.StrDescription = txtDescription.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_IDENTIFICATION_TYPES_obj.saveIdentificationDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_IDENTIFICATION_TYPES.loadIdentificationType(cboIdentificationTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_IDENTIFICATION_TYPES_obj.updateIdentificationDetails(intIdentificationTypeID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_IDENTIFICATION_TYPES.loadIdentificationType(cboIdentificationTypes );
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }

        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intIdentificationTypeID == 0 || txtIdentificationType.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the identification type to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the identification type. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboIdentificationTypes_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void frm_IDENTIFICATION_TYPES_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (frm_BANK_ACCOUNTS.int_frm_IDENTIFICATION_TYPE_ID == 1)
            {
                cls_IDENTIFICATION_TYPES.loadIdentificationType(frm_BANK_ACCOUNTS.frm_BANK_ACCOUNTS_obj.cboIdentification);
            }
        }
    }
}