/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;
using BMS.FORMS;

namespace BMS
{
    public partial class frm_LOGIN : Form
    {

        cls_GLOBAL_VARIABLES cls_GLOBAL_VARIABLES_OBJ = new cls_GLOBAL_VARIABLES();
        cls_USERS cls_USERS_OBJ = new cls_USERS();

        public frm_LOGIN()
        {
            InitializeComponent();
        }

        private void btnQuit_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.displayMessage("Are you sure you want to quit application?") == true) { Application.Exit(); }
        }

        private void frm_LOGIN_Load(object sender, EventArgs e)
        {
            
        }

        private void btnLogin_Click(object sender, EventArgs e)
        {
            cls_GLOBAL_VARIABLES.blLoginStatus = false ;
            cls_USERS_OBJ.StrUserName = txtUserName.Text.Trim();
            cls_USERS_OBJ.StrPassword = txtPassword.Text.Trim();
            if (cls_USERS_OBJ.CheckUserLogin() == false)
            {
                cls_UTILITY.displayMessage("Invalid User", MessageBoxIcon.Exclamation);
            }
            else
            {
                cls_GLOBAL_VARIABLES.intUserID = cls_USERS_OBJ.IntUserID;
                loadUserDetails(cls_GLOBAL_VARIABLES.intUserID);
                if (cls_GLOBAL_VARIABLES.intStatus == 0)
                {
                    cls_UTILITY.displayMessage("Sorry! Your account has been disabled", MessageBoxIcon.Exclamation);
                }
                else if (cls_GLOBAL_VARIABLES.intActive == 1)
                {
                    cls_UTILITY.displayMessage("Sorry! User already logged in", MessageBoxIcon.Exclamation);
                    chkLogUserOff.Visible = true;
                }
                else if (cls_GLOBAL_VARIABLES.intDeleted == 1)
                {
                    cls_UTILITY.displayMessage("Sorry! Your account has been deleted", MessageBoxIcon.Exclamation);
                }
                else
                {
                    saveUserAccessLogIn(cls_GLOBAL_VARIABLES.intUserID);
                    frm_MAIN.frm_MAIN_obj.loadFeatures(cls_GLOBAL_VARIABLES.intUserID);
                    cls_GLOBAL_VARIABLES.blLoginStatus = true;
                    Close();
                }
            }
        }



        private void loadUserDetails(int intUserID)
        {
            cls_USERS_OBJ.loadUserDetails(intUserID);
            cls_GLOBAL_VARIABLES.strUserName = cls_USERS_OBJ.StrUserName ;
            cls_GLOBAL_VARIABLES.strFullName = cls_USERS_OBJ.StrFullName ;
            cls_GLOBAL_VARIABLES.strPassword = cls_USERS_OBJ.StrPassword ;
            cls_GLOBAL_VARIABLES.intStatus = cls_USERS_OBJ.IntStatus ;
            cls_GLOBAL_VARIABLES.intDeleted = cls_USERS_OBJ.IntDeleted ;
            cls_GLOBAL_VARIABLES.intActive = cls_USERS_OBJ.IntActive ;
            cls_GLOBAL_VARIABLES.intAdmin = cls_USERS_OBJ.IntAdmin ;
            cls_GLOBAL_VARIABLES.intUserID = cls_USERS_OBJ.IntUserID;
        }

        private void saveUserAccessLogIn(int intUserID)
        {
            cls_USERS_OBJ.StrWorkStationName = cls_UTILITY.getComputerName();
            cls_USERS_OBJ.saveUserAccessLogIn(intUserID);
            cls_USERS_OBJ.updateUserLogInDetails(intUserID);
        }

        //private void loadProgramSettings()
        //{
        //    cls_OPTIONS.LoadProgramSettings();
        //}

        private void frm_LOGIN_FormClosed(object sender, FormClosedEventArgs e)
        {

        }

        private void chkLogUserOff_CheckedChanged(object sender, EventArgs e)
        {
            if (cls_UTILITY.displayMessage("Are you sure you want to log user off?") == true)
            {
                if (cls_USERS_OBJ.setUserInActive(cls_GLOBAL_VARIABLES.intUserID) == 1)
                {
                    cls_UTILITY.displayMessage(txtUserName.Text + "'s account has been log off", MessageBoxIcon.Information);
                }
                else
                {
                    cls_UTILITY.displayMessage("Unable to log " + txtUserName.Text + "'s off", MessageBoxIcon.Information);
                }
                chkLogUserOff.Visible = false ;
            }
            else
            {
                //chkLogUserOff.Checked = false;
                chkLogUserOff.Visible = true;
            }
        }

    }
}