/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using Microsoft.Reporting.WinForms;

using BMS.CLASSES;
namespace BMS.FORMS
{
    public partial class frm_REPORT_VIEWER : Form
    {
        public static string strSQL;
        public static int intAccountID;
        public static bool blAccount = false;
        public static int intCustomerID;
        public static int intTransactionID;
        public static bool blCustomer = false;
        public static bool blTransaction = false;
        public static bool blBankStatement = false;
        public static frm_REPORT_VIEWER frm_REPORT_VIEWER_obj= new frm_REPORT_VIEWER();

        public frm_REPORT_VIEWER()
        {
            InitializeComponent();
        }

        private void frm_REPORT_VIEWER_Load(object sender, EventArgs e)
        {
            if (blAccount == true) { loadAccountDetailsReport(); }
            else if (blCustomer == true) { loadCustomerDetailsReport(); }
            else if (blTransaction == true) { loadTransactionDetailsReport(); }
            else if (blBankStatement == true) { loadBankStatementReport(); }
        }

        private void loadAccountDetailsReport()
        {
            
            cls_BANK_ACCOUNTS.loadAccountDetailsReport(strSQL, rdlcviewer, "BMS.REPORTS.rpt_ACCOUNT_DETAILS.rdlc", "ds_TABLES_vw_ACCOUNT_DETAILS", intAccountID);
            reset();
        }

        private void loadCustomerDetailsReport()
        {
            cls_BANK_ACCOUNTS.loadCustomerDetailsReport(strSQL, rdlcviewer, "BMS.REPORTS.rpt_ACCOUNT_DETAILS.rdlc", "ds_TABLES_vw_ACCOUNT_DETAILS", intCustomerID);
            reset();
        }

        private void loadTransactionDetailsReport()
        {
            cls_TRANSACTIONS.loadTransactionReport(strSQL, rdlcviewer, "BMS.REPORTS.rpt_TRANSACTIONS.rdlc", "ds_TABLES_vw_TRANSACTION_DETAILS", intTransactionID);
            reset();
        }

        private void loadBankStatementReport()
        {
            cls_BANK_STATEMENT.loadBankStatementReport(strSQL, rdlcviewer, "BMS.REPORTS.rpt_BANK_STATEMENT.rdlc", "ds_TABLES_vw_BANK_STATEMENT");
            reset();
        }

        private void reset()
        {
            blAccount = false;
            blCustomer = false;
            blTransaction = false;
            blBankStatement = false;
        }

    }
}