/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;

namespace BMS.FORMS
{
    public partial class frm_TITLE_TYPES : Form
    {

        int intTitleID = 0;
        cls_TITLE_TYPES cls_TITLE_TYPES_obj = new cls_TITLE_TYPES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_TITLE_TYPES()
        {
            InitializeComponent();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frm_TITLE_TYPES_Load(object sender, EventArgs e)
        {
            cls_TITLE_TYPES.loadTitleTypes(cboTitleTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboTitleTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboTitleTypes.SelectedItem;
            intTitleID = cls_LIST_ITEM_obj.ListID;
            loadTitleDetails(intTitleID);
        }

        private void loadTitleDetails(int intTitleID)
        {
            cls_TITLE_TYPES_obj.loadTitleTypesDetails(intTitleID);

            txtTitleName.Text = cls_TITLE_TYPES_obj.StrTitleName;
            txtTitleShortName.Text = cls_TITLE_TYPES_obj.StrTitleShortName;
            txtDescription.Text = cls_TITLE_TYPES_obj.StrDescription;
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboTitleTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboTitleTypes.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intTitleID == 0 || txtTitleShortName.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the title to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtTitleShortName, "Please enter the title name") == false) { disableCtl(); }

            cls_TITLE_TYPES_obj.StrTitleName  = txtTitleName.Text.Trim();
            cls_TITLE_TYPES_obj.StrTitleShortName = txtTitleShortName.Text.Trim();
            cls_TITLE_TYPES_obj.StrDescription = txtDescription.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_TITLE_TYPES_obj.saveTitleDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_TITLE_TYPES.loadTitleTypes(cboTitleTypes );
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_TITLE_TYPES_obj.updateTitleDetails(intTitleID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_TITLE_TYPES.loadTitleTypes(cboTitleTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }

        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intTitleID == 0 || txtTitleShortName.Text.Trim()==string.Empty) { cls_UTILITY.displayMessage("Please select the title to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the title type. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboTitleTypes_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void frm_TITLE_TYPES_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (frm_BANK_ACCOUNTS.int_frm_TITLE_TYPE_ID == 1)
            {
                cls_TITLE_TYPES.loadTitleTypes(frm_BANK_ACCOUNTS.frm_BANK_ACCOUNTS_obj.cboTitle);
            }
        }
    }
}