/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Collections;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_TRANSACTIONS : DockableWindow
    {
        string strSeach;
        int intTransactionID = 0;
        int intTransactionTypeID = 0;
        int intFromAccountID = 0;
        int intToAccountID = 0;
        int intStatus = 0;

        cls_TRANSACTIONS cls_TRANSACTIONS_obj = new cls_TRANSACTIONS();

        public frm_TRANSACTIONS()
        {
            InitializeComponent();
        }

        private void frm_TRANSACTIONS_Load(object sender, EventArgs e)
        {
            reset();
            fillComboBoxes();
        }

        private void fillComboBoxes()
        {
            cls_TRANSACTION_TYPES.loadTransactionTypes(cboTransactionType);
            cls_BANK_ACCOUNTS.loadAccountNo (cboFromAccountNo);
            cls_BANK_ACCOUNTS.loadAccountNo(cboToAccountNo);
            loadStatus();
        }

        private void loadStatus()
        {
            ArrayList ArrayList_Obj = new ArrayList();
            ArrayList_Obj.Add(new cls_LIST_ITEM("Pending", 0));
            ArrayList_Obj.Add(new cls_LIST_ITEM("Posted", 1));
            cboStatus.DataSource = ArrayList_Obj;
            cboStatus.DisplayMember = "strListItem";
            cboStatus.DisplayMember = "intListID";
            cboStatus.SelectedIndex = -1;
        }

        private void reset()
        {
            cls_UTILITY.ClearFields(grpBoxTransaction);
            dtpFromTransactionDate.Checked = false;
            dtpToTransactionDate.Checked = false;
            lvwTransactions.Items.Clear();
            btnPost.Enabled = false;
            lblNoRecord.Text = "0 Record Found";
        }


        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void cboTransactionType_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboTransactionType.SelectedItem;
                intTransactionTypeID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void cboFromAccountNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboFromAccountNo.SelectedItem;
                intFromAccountID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void cboToAccountNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM lstItem = (cls_LIST_ITEM)cboToAccountNo.SelectedItem;
                intToAccountID = lstItem.ListID;
            }
            catch (Exception Exc) { }
        }

        private void cboStatus_SelectedIndexChanged(object sender, EventArgs e)
        {
            intStatus = cboStatus.SelectedIndex;
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            search();
        }

        private void search()
        {
            strSeach = string.Empty;


            if (dtpFromTransactionDate.Checked == true )
            {
                if (strSeach == "") { strSeach = strSeach + " TransactionDate >= #" + dtpFromTransactionDate.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND TransactionDate >= #" + dtpFromTransactionDate.Value.ToShortDateString() + "#"; }
            }

            if (dtpToTransactionDate.Checked == true)
            {
                if (strSeach == "") { strSeach = strSeach + " TransactionDate <= #" + dtpToTransactionDate.Value.ToShortDateString() + "#"; }
                else { strSeach = strSeach + " AND TransactionDate <= #" + dtpToTransactionDate.Value.ToShortDateString() + "#"; }
            }

            if (intTransactionTypeID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " TransactionTypeID = " + intTransactionTypeID; }
                else { strSeach = strSeach + " AND TransactionTypeID = " + intTransactionTypeID; }
            }

            if (intFromAccountID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " FromAccountID = " + intFromAccountID; }
                else { strSeach = strSeach + " AND FromAccountID = " + intFromAccountID; }
            }

            if (intToAccountID > 0)
            {
                if (strSeach == "") { strSeach = strSeach + " ToAccountID = " + intToAccountID; }
                else { strSeach = strSeach + " AND ToAccountID = " + intToAccountID; }
            }

            if (txtChequeNo.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " ChequeNumber = '" + txtChequeNo.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND ChequeNumber = '" + txtChequeNo.Text.Trim() + "'"; }
            }

            if (txtAmount.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " Amount = '" + txtAmount.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND Amount = '" + txtAmount.Text.Trim() + "'"; }
            }

            if (intStatus >= 0)
            {
                if (strSeach == "") { strSeach = strSeach + " Status = " + intStatus; }
                else { strSeach = strSeach + " AND Status = " + intStatus; }
            }

            if (txtDepositedBy.Text.Trim() != "")
            {
                if (strSeach == "") { strSeach = strSeach + " DepositedBy = '" + txtDepositedBy.Text.Trim() + "'"; }
                else { strSeach = strSeach + " AND DepositedBy = '" + txtDepositedBy.Text.Trim() + "'"; }
            }



            if (strSeach != string.Empty)
            {
                cls_TRANSACTIONS.searchTransactions(lvwTransactions, strSeach);
                lblNoRecord.Text = lvwTransactions.Items.Count + " Records Found";
                
            }
            else { lvwTransactions.Items.Clear(); }

            getTotalAmount();

        }

        private void getTotalAmount()
        {
            int intCount = lvwTransactions.Items.Count;
            long lngTotalAmount=0;
            for(int x = 0 ; x < intCount ; x++)
            {
                lngTotalAmount=lngTotalAmount + Convert.ToInt64(  lvwTransactions.Items[x].SubItems[6].Text);
            }
            lblTotal.Text = lngTotalAmount.ToString() ;
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            reset();
        }

        private void lvwTransactions_Click(object sender, EventArgs e)
        {
            intTransactionID = Convert.ToInt32(lvwTransactions.Items[lvwTransactions.FocusedItem.Index].SubItems[0].Text);
            if(Convert.ToInt16( lvwTransactions.Items[lvwTransactions.FocusedItem.Index].SubItems[9].Text)==0)
            {
                btnPost.Enabled = true ;
            }
            else
            {
                btnPost.Enabled = false;
            }
            //MessageBox.Show(lvwTransactions.Items[lvwTransactions.FocusedItem.Index ].SubItems[11].Text);
        }

        private void btnPost_Click(object sender, EventArgs e)
        {
            cls_TRANSACTIONS_obj.LngTotalBalance = Convert.ToInt64(lvwTransactions.Items[lvwTransactions.FocusedItem.Index].SubItems[6].Text);
            if (cls_TRANSACTIONS_obj.updateTransactionBalance  (Convert.ToInt16(lvwTransactions.Items[lvwTransactions.FocusedItem.Index].SubItems[11].Text)) == 0 & cls_TRANSACTIONS_obj.updateTransactionStatus(Convert.ToInt16(lvwTransactions.Items[lvwTransactions.FocusedItem.Index].SubItems[0].Text ))==0)
            {
                cls_UTILITY.displayMessage("An error occured while updating balance. Please retry", MessageBoxIcon.Error);
            }
            else
            {
                cls_UTILITY.displayMessage("Details successfully saved. Please retry", MessageBoxIcon.Information);
                search();
                btnPost.Enabled = false;
            }
        }

        private void btnPreviewAll_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.blTransaction = true;
            frm_REPORT_VIEWER.intTransactionID = 0;
            frm_REPORT_VIEWER.strSQL = strSeach;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void btnPreviewSelected_Click(object sender, EventArgs e)
        {
            frm_REPORT_VIEWER.blTransaction = true;
            frm_REPORT_VIEWER.intTransactionID = 0;
            frm_REPORT_VIEWER.intTransactionID = intTransactionID;
            frm_REPORT_VIEWER.strSQL = strSeach;
            frm_REPORT_VIEWER frm = new frm_REPORT_VIEWER();
            frm.Show();
        }

        private void lvwTransactions_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}