/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using BMS.CLASSES;
namespace BMS.FORMS
{
    public partial class frm_TRANSACTION_TYPES : Form
    {

        int intTransactionTypeID= 0;
        cls_TRANSACTION_TYPES cls_TRANSACTION_TYPES_obj = new cls_TRANSACTION_TYPES();
        bool blAdd = false;
        bool blEdit = false;

        public frm_TRANSACTION_TYPES()
        {
            InitializeComponent();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void frm_TRANSACTION_TYPES_Load(object sender, EventArgs e)
        {
            cls_TRANSACTION_TYPES.loadTransactionTypes(cboTransactionTypes);
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void cboTransactionTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboTransactionTypes.SelectedItem;
            intTransactionTypeID = cls_LIST_ITEM_obj.ListID;
            loadTransactionTypesDetails(intTransactionTypeID);
        }

        private void loadTransactionTypesDetails(int intTransactionTypeID)
        {
            cls_TRANSACTION_TYPES_obj.loadTransactionTypeDetails(intTransactionTypeID);

            txtTransactionType.Text = cls_TRANSACTION_TYPES_obj.StrTransactionType;
            txtDescription.Text = cls_TRANSACTION_TYPES_obj.StrDescription;
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboTransactionTypes.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboTransactionTypes.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxDetails);
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intTransactionTypeID == 0 || txtTransactionType.Text.Trim()==string.Empty ) { cls_UTILITY.displayMessage("Please select the transaction type to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            cls_UTILITY.enableFields(grpBoxDetails);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            cls_UTILITY.disableFields(grpBoxDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtTransactionType, "Please enter the transaction type") == false) { disableCtl(); }

            cls_TRANSACTION_TYPES_obj.StrTransactionType = txtTransactionType.Text.Trim();
            cls_TRANSACTION_TYPES_obj.StrDescription = txtDescription.Text.Trim();

            if (blAdd == true && blEdit == false)
            {
                if (cls_TRANSACTION_TYPES_obj.saveTransactionTypeDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_TRANSACTION_TYPES.loadTransactionTypes(cboTransactionTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_TRANSACTION_TYPES_obj.updateTransactionTypeDetails(intTransactionTypeID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_TRANSACTION_TYPES.loadTransactionTypes(cboTransactionTypes);
                    cls_UTILITY.disableFields(grpBoxDetails);
                }
            }

        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intTransactionTypeID == 0 || txtTransactionType.Text.Trim()==string.Empty ) { cls_UTILITY.displayMessage("Please select the transaction type to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the transaction type. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void cboTransactionTypes_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }
    }
}