/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_USERS : DockableWindow
    {
        int intStatus = 0;
        int intUserID = 0;
        bool blAdd = false;
        bool blEdit = false;

        string strCurrentPictureName;
        string strPictureSource;
        string strPictureName ;
        string strPictureExtension;

        cls_USERS cls_USERS_obj = new cls_USERS();
        public static frm_USERS frm = null;

        public static frm_USERS Instance()
        {
            if (frm == null)
            {
                frm = new frm_USERS();
            }
            return frm;
        }

        public frm_USERS()
        {
            InitializeComponent();
        }

        private void frm_USERS_Load(object sender, EventArgs e)
        {
            cls_USERS.loadUsers(cboUsers);
            cls_FEATURES.loadFeatures(lvwFeatures);
            disableCtl();
            disableFields();
        }

        private void cboUsers_SelectedIndexChanged(object sender, EventArgs e)
        {
            cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboUsers.SelectedItem;
            intUserID = cls_LIST_ITEM_obj.ListID;
            loadUserDetails(intUserID);
        }

        private void loadUserDetails(int intUserID)
        {
            cls_USERS_obj.loadUserDetails(intUserID);

            txtUserName.Text = cls_USERS_obj.StrUserName;
            txtFullName.Text = cls_USERS_obj.StrFullName;
            txtPassword.Text = cls_USERS_obj.StrPassword;

            if (cls_USERS_obj.IntAdmin == 0)
            {
                chkAdmin.Checked = false;
            }
            else if (cls_USERS_obj.IntAdmin == 1)
            {
                chkAdmin.Checked = true;
            }

            if (cls_USERS_obj.IntStatus == 1)
            {
                intStatus = 0;
                lblAccountStatus.Text = "ENABLED";
                lblAccountStatus.BackColor = Color.Green;
                btnDisableAccount.Text = "Disable";
            }
            else if (cls_USERS_obj.IntStatus == 0)
            {
                intStatus = 1;
                lblAccountStatus.Text = "DISABLED";
                lblAccountStatus.BackColor = Color.Red;
                btnDisableAccount.Text = "Enable";
            }

            if (cls_USERS_obj.IntActive == 0)
            {
                lblCurrentStatus.Text = "NOT LOGGED IN";
                lblCurrentStatus.BackColor = Color.Red;
                btnLogOffCurentUser.Enabled = false;
            }
            else if (cls_USERS_obj.IntActive == 1)
            {
                lblCurrentStatus.Text = "LOGGED IN";
                lblCurrentStatus.BackColor = Color.Green;
                btnLogOffCurentUser.Enabled = true;
                btnLogOffCurentUser.Text = "Log Off";
            }
            lblLastLoginDate.Text =DateTime.Parse( cls_USERS_obj.DtLastLoginDate.ToString()).ToShortDateString();
            lblLastLoginWorkstation.Text = cls_USERS_obj.StrLastLoginWorkstation;
            //lblLocation.Text = cls_USERS_obj.IntLocationID;

            if (cls_USERS_obj.StrPicture == "") { pic.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp"); strCurrentPictureName = ""; }
            else { pic.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_USERS_obj.StrPicture); strCurrentPictureName = cls_USERS_obj.StrPicture; }

            cls_FEATURES.loadFeatures(intUserID);

            cls_UTILITY.uncheckLvwItem(lvwFeatures);

            foreach (ListViewItem lvwItem in lvwFeatures.Items)
            {
                foreach (int x in cls_GLOBAL_VARIABLES.arrayList)
                {
                    if (Convert.ToInt16(lvwItem.SubItems[1].Text) == x)
                    {
                        lvwItem.Checked = true;
                    }
                }
            }


        }


        private void btnResetPassword_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtPassword, "Please select the user whose password should be reset.") == true ) { disableCtl(); }

            //if (cls_GLOBAL_VARIABLES.intUserID == intUserID)
            //{
            //    if (cls_UTILITY.displayMessage("You will have to log in again if you should reset your password. \n Do you want to continue?") == true)
            //    {
            //        cls_UTILITY.displayMessage(txtUserName.Text + "'s password has been reset to 'password'", MessageBoxIcon.Information);
            //        this.Close();
            //        frm_LOGIN frm_LOGIN_obj = new frm_LOGIN();
            //        frm_LOGIN_obj.ShowDialog();
            //    }
            //}
            //else
            //{
                if (cls_USERS_obj.resetUserPassword(intUserID) == 1)
                {
                    cls_UTILITY.displayMessage(txtUserName.Text + "'s password has been reset to 'password'", MessageBoxIcon.Information);
                    
                }
                else
                {
                    cls_UTILITY.displayMessage("Unable to reset " + txtUserName.Text + "'s password to 'password'", MessageBoxIcon.Information);
                }
            //}
                loadUserDetails(intUserID);
        }

        private void disableCtl()
        {
            btnAddNew.Enabled = true;
            btnEdit.Enabled = true;
            btnDelete.Enabled = true;
            btnClose.Enabled = true;

            cboUsers.Enabled = true;

            btnCancel.Enabled = false;
            btnSave.Enabled = false;

        }

        private void enableCtl()
        {
            btnAddNew.Enabled = false;
            btnEdit.Enabled = false;
            btnDelete.Enabled = false;
            btnClose.Enabled = false;

            cboUsers.Enabled = false;

            btnCancel.Enabled = true;
            btnSave.Enabled = true;
        }

        private void enableFields()
        {
            cls_UTILITY.enableFields(grpBoxUsers);
            cls_UTILITY.enableFields(grpBoxFeatures);
            cls_UTILITY.enableFields(grpBoxPic);
        }

        private void disableFields()
        {
            cls_UTILITY.disableFields(grpBoxUsers);
            cls_UTILITY.disableFields(grpBoxFeatures);
            cls_UTILITY.disableFields(grpBoxPic);
        }

        private void btnAddNew_Click(object sender, EventArgs e)
        {
            blAdd = true;
            blEdit = false;
            cls_UTILITY.ClearFields(grpBoxUsers);
            enableCtl();
            enableFields();
            txtPassword.Text = "password";
            pic.Image = null;
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (intUserID == 0 || txtUserName.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the user to edit", MessageBoxIcon.Exclamation); return; }
            blEdit = true;
            blAdd = false;
            enableCtl();
            enableFields();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (intUserID == 0 || txtUserName.Text.Trim() == string.Empty) { cls_UTILITY.displayMessage("Please select the user to delete", MessageBoxIcon.Exclamation); return; }
            cls_UTILITY.displayMessage("Unable to delete the user. It might be referenced somewhere else.", MessageBoxIcon.Error);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            disableCtl();
            disableFields();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtUserName, "Please enter the user name") == true ) { return ; }
            if (cls_UTILITY.checkEmptyTextBox(txtFullName, "Please enter the fullname") == true) { return ; }
            if (cls_UTILITY.checkImage(pic, "Please select the user picture before saving") == true) { return; }

            cls_USERS_obj.IntUserID=cls_USERS.AutogenID();
            cls_USERS_obj.StrUserName = txtUserName.Text.Trim();
            cls_USERS_obj.StrFullName = txtFullName.Text.Trim();
            cls_USERS_obj.StrPassword = txtPassword.Text.Trim();


            if (strPictureName == null || strPictureName == "")
            { cls_USERS_obj.StrPicture = strCurrentPictureName; }
            else
            {
                cls_USERS_obj.StrPicture = strPictureName;
                if (cls_UTILITY.CopyImage(strPictureSource, cls_GLOBAL_VARIABLES.strPictureDestination, strPictureName) == false)
                {
                    cls_UTILITY.displayMessage("The picture already exists. Kindly change it", MessageBoxIcon.Exclamation);
                    return;
                }
            }

            if (blAdd == true && blEdit == false)
            {
                if (cls_USERS_obj.saveUserDetails() != 1)
                { cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    //cls_USERS_obj.deleteUserFeatures(cls_USERS_obj.IntUserID);
                    foreach (ListViewItem lvwItem in lvwFeatures.Items)
                    {
                        if (lvwItem.Checked == true)
                        {
                            cls_USERS_obj.IntUserFeatureID = Convert.ToInt16(lvwItem.SubItems[1].Text);
                            cls_USERS_obj.saveUserFeatures(cls_USERS_obj.IntUserID);
                        }
                    }

                    cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                    cls_USERS.loadUsers(cboUsers );
                    disableCtl();
                    disableFields();
                }
            }
            else if (blAdd == false && blEdit == true)
            {
                if (cls_USERS_obj.updateUserDetails(intUserID) != 1)
                { cls_UTILITY.displayMessage("An error occured while updating data. Please retry", MessageBoxIcon.Error); }
                else
                {
                    cls_USERS_obj.deleteUserFeatures(intUserID);
                    foreach (ListViewItem lvwItem in lvwFeatures.Items)
                    {
                        if (lvwItem.Checked == true)
                        {
                            cls_USERS_obj.IntUserFeatureID = Convert.ToInt16(lvwItem.SubItems[1].Text);
                            cls_USERS_obj.saveUserFeatures(intUserID);
                        }
                    }
                    cls_UTILITY.displayMessage("Details updated successfully", MessageBoxIcon.Information);
                    cls_USERS.loadUsers(cboUsers);
                    disableCtl();
                    disableFields();
                }
            }
        }



        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnDisableAccount_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtPassword, "Please select the user whose account should be disabled.") == false) { disableCtl(); }

            if (cls_USERS_obj.setUserAccountStatus(intUserID,intStatus) == 1)
            {
                cls_UTILITY.displayMessage(txtUserName.Text + "'s account has been set", MessageBoxIcon.Information);
                loadUserDetails(intUserID);
            }
            else
            {
                cls_UTILITY.displayMessage("Unable to set " + txtUserName.Text + "'s account", MessageBoxIcon.Information);
            }
        }

        private void btnLogOffCurentUser_Click(object sender, EventArgs e)
        {
            if (cls_UTILITY.checkEmptyTextBox(txtPassword, "Please select the user whose account should be logged off.") == false) { disableCtl(); }
            if (cls_USERS_obj.setUserInActive(intUserID) == 1)
            {
                cls_UTILITY.displayMessage(txtUserName.Text + "'s account has been log off", MessageBoxIcon.Information);
                loadUserDetails(intUserID);
            }
            else
            {
                cls_UTILITY.displayMessage("Unable to log " + txtUserName.Text + "'s off", MessageBoxIcon.Information);
            }
        }

        private void btnBrowsePicture_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();

            openFileDialog.InitialDirectory = "C:/";
            openFileDialog.Filter = "All Files|*.*|Bitmaps|*.bmp|GIFs|*.gif|JPEGs|*.jpg";
            openFileDialog.FilterIndex = 2;

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                pic.Image = Image.FromFile(openFileDialog.FileName);
                pic.SizeMode = PictureBoxSizeMode.StretchImage;
                pic.BorderStyle = BorderStyle.Fixed3D;
                strPictureSource = openFileDialog.FileName;
                string[] strPicturename = strPictureSource.Split('\\');
                strPictureName = strPicturename[strPicturename.Length - 1].ToString();
                strPictureExtension = new FileInfo(openFileDialog.FileName).Extension;
            }
        }

        private void chkSelectAllFeatures_CheckedChanged(object sender, EventArgs e)
        {
            foreach (ListViewItem lvwItem in lvwFeatures.Items)
            {
                lvwItem.Checked = chkSelectAllFeatures.Checked;
            }

        }
    }
}