/****************************************************************
*	TITLE               :   BMS                                 *
*   APPLICATION DOMAIN  :   Bank Management System              *
*   VERSION             :   1.0                                 *
*   DEVELOPER           :	Mr. Abdel Raouf Yessoufou           *
*	SYSTEM ANALIST      :   Mr. Abdel Raouf Yessoufou           *
*	SYSTEM DESIGNER     :	Mr. Abdel Raouf Yessoufou           *
*	DATABASE DESIGNER   :	Mr. Abdel Raouf Yessoufou           *
*   YEAR CREATED        :   2008                                *
*   NOTES               :   This is just the begining.          *
*                           The best is yet to come as          *
*                           I am looking forward to adding      *
*                           more features for next version      *
*****************************************************************/

using System;
using System.Windows.Forms;
using System.Drawing;
using BMS.CLASSES;
using Fireball.Docking;

namespace BMS.FORMS
{
    public partial class frm_WITHDRAWAL : DockableWindow
    {
        private int intAccountID;
        private int intChequeID;

        cls_UTILITY cls_UTILITY_obj = new cls_UTILITY();
        cls_TRANSACTIONS cls_TRANSACTIONS_obj = new cls_TRANSACTIONS();
        cls_BANK_ACCOUNTS cls_BANK_ACCOUNTS_obj = new cls_BANK_ACCOUNTS();
        
        public frm_WITHDRAWAL()
        {
            InitializeComponent();
        }

        private void frm_WITHDRAWAL_Load(object sender, EventArgs e)
        {
            cls_BANK_ACCOUNTS.loadAccountNo(cboAccounts);
            cls_UTILITY.disableFields(grpBoxTransactionDetails);
        }

        private void cboAccounts_SelectedIndexChanged(object sender, EventArgs e)
        {
            //try
            //{
                cls_UTILITY.ClearFields(grpBoxTransactionDetails);
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboAccounts.SelectedItem;
                intAccountID = cls_LIST_ITEM_obj.ListID;
                loadAccountDetails(intAccountID);
                cls_BANK_ACCOUNTS_obj.loadChequeNo(cboChequeNo, intAccountID);
            //}
            //catch (Exception ex) { }
        }

        private void loadAccountDetails(int intAccountID)
        {
            cls_BANK_ACCOUNTS_obj.loadAccountDetails(intAccountID);


            lblFullName.Text = cls_BANK_ACCOUNTS_obj.StrTitleShortName + " " + cls_BANK_ACCOUNTS_obj.StrSurname + " " + cls_BANK_ACCOUNTS_obj.StrOtherNames + " " + cls_BANK_ACCOUNTS_obj.StrMaidenName;
            lblGender.Text = cls_BANK_ACCOUNTS_obj.StrGender;
            lblOfficePhone.Text = cls_BANK_ACCOUNTS_obj.StrOfficePhone;
            lblHomePhone.Text = cls_BANK_ACCOUNTS_obj.StrHomePhone;
            lblEMailAddress.Text = cls_BANK_ACCOUNTS_obj.StrEmail;
            lblPOBox.Text = cls_BANK_ACCOUNTS_obj.StrPOBox;

            lblAccountNo.Text = cls_BANK_ACCOUNTS_obj.StrAccountNo;
            lblAccountName.Text = cls_BANK_ACCOUNTS_obj.StrAccountName;
            lblAccountType.Text = cls_BANK_ACCOUNTS_obj.StrAccountType;
            lblCurrencyType.Text = cls_BANK_ACCOUNTS_obj.StrCurrencyType;
            lblBalance.Text = cls_BANK_ACCOUNTS_obj.StrBalance;
            lblDateOpened.Text = cls_BANK_ACCOUNTS_obj.DtDateOpened.ToString();

            lblMinimumBalance.Text = cls_BANK_ACCOUNTS_obj.LngMinimumBalance.ToString();

            if (cls_BANK_ACCOUNTS_obj.StrPicture == "") { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoPicture.bmp"); }
            else { AccountHolderPicture.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrPicture); }

            if (cls_BANK_ACCOUNTS_obj.StrDigitalSign == "") { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\NoSignature.bmp"); }
            else { AccountHolderDigitalSign.Image = Image.FromFile(cls_GLOBAL_VARIABLES.strPictureDestination + @"\" + cls_BANK_ACCOUNTS_obj.StrDigitalSign); }

        }

        private void txtAmount_TextChanged(object sender, EventArgs e)
        {
            if (txtAmount.Text == "")
            {
                lblAmountInWords.Text = "";
                lblTotalBalance.Text = "";
                return;
            }
            else
            {
                lblAmountInWords.Text = cls_UTILITY_obj.IntegerToWords(Convert.ToInt64(txtAmount.Text));
                long lngTotal = Convert.ToInt64(lblBalance.Text) - Convert.ToInt64(txtAmount.Text);
                lblTotalBalance.Text = lngTotal.ToString();
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            cls_UTILITY.ClearFields(grpBoxTransactionDetails);
            btnCancel.Enabled = false ;
            btnSave.Enabled = false ;
            btnNewWithdrawal.Enabled = true ;
            cboAccounts.Enabled = true;
            cls_UTILITY.disableFields(grpBoxTransactionDetails);
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            
            if (cls_UTILITY.checkEmptyTextBox(txtAmount, "Please enter the amount to withdraw") == true) { return; }
            if (cls_UTILITY.checkEmptyTextBox(txtWithdrawnBy, "Please enter the name of the withdrawer") == true) { return; }

            if (Convert.ToInt64(lblTotalBalance.Text) < Convert.ToInt64(lblMinimumBalance.Text))
            {
                cls_UTILITY.displayMessage("The minimum balance of " + lblAccountType.Text.Trim() + " is " + lblMinimumBalance.Text.Trim() + ". \n Sorry! The balance can not be less than the minimum balance", MessageBoxIcon.Error);
                return;
            }

            cls_TRANSACTIONS_obj.IntTransactionID = cls_TRANSACTIONS.AutogenID();
            cls_TRANSACTIONS_obj.DtTransactionDate = DateTime.Today;
            cls_TRANSACTIONS_obj.IntTransactionTypeID = 3;//1 means Withdrawal
            cls_TRANSACTIONS_obj.StrTransactionMode = "Withdrawal";
            cls_TRANSACTIONS_obj.IntFromAccountID = intAccountID;
            cls_TRANSACTIONS_obj.StrFromAccountNo = lblAccountNo.Text.Trim();
            cls_TRANSACTIONS_obj.IntToAccountID = 0;
            cls_TRANSACTIONS_obj.StrToAccountNo = "";
            cls_TRANSACTIONS_obj.IntChequeNumber = intChequeID;
            cls_TRANSACTIONS_obj.StrChequeNumber = cboChequeNo.Text.Trim() ;
            cls_TRANSACTIONS_obj.LngAmount = Convert.ToInt64(txtAmount.Text);
            cls_TRANSACTIONS_obj.IntStatus = 1;
            cls_TRANSACTIONS_obj.StrDepositedBy = txtWithdrawnBy.Text.Trim();
            cls_TRANSACTIONS_obj.LngTotalBalance = Convert.ToInt64(lblTotalBalance.Text);

            if (cls_TRANSACTIONS_obj.saveTransactions() == 0 & cls_TRANSACTIONS_obj.updateBalance(intAccountID) == 0 & cls_TRANSACTIONS_obj.updateChequeStatus(intChequeID) == 0)
            {
                cls_UTILITY.displayMessage("An error occured while saving data. Please retry", MessageBoxIcon.Error);
            }
            else
            {
                cls_UTILITY.displayMessage("Details saved successfully", MessageBoxIcon.Information);
                cls_UTILITY.ClearFields(grpBoxTransactionDetails);
                //cls_BANK_ACCOUNTS.loadAccountNo(cboAccounts);
                loadAccountDetails(intAccountID);
                cls_UTILITY.disableFields(grpBoxTransactionDetails);
                cboAccounts.Enabled = true;
                btnCancel.Enabled = false;
                btnSave.Enabled = false;
                btnNewWithdrawal.Enabled = true;
                intAccountID = 0;
            }
        }

        private void btnClose_Click(object sender, EventArgs e){Close();}

        private void btnNewWithdrawal_Click(object sender, EventArgs e)
        {
            if (intAccountID == 0)
            {
                cls_UTILITY.displayMessage("Please select account no", MessageBoxIcon.Exclamation);
            }
            else
            {
                cboAccounts.Enabled = false;
                btnCancel.Enabled = true;
                btnSave.Enabled = true;
                btnNewWithdrawal.Enabled = false;
                cls_UTILITY.enableFields(grpBoxTransactionDetails);
            }
        }

        private void cboChequeNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cls_LIST_ITEM cls_LIST_ITEM_obj = (cls_LIST_ITEM)cboChequeNo.SelectedItem;
                intChequeID = cls_LIST_ITEM_obj.ListID;
            }
            catch (Exception exc)
            {
            }
        }

    }
}